/*
 *
 * Released under GPL
 *
 * Copyright (C) 2007  Al. Nander
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Description:
 *   Prepare text files to be read by FURCH (Unix version)
 *
 */
#define _GNU_SOURCE
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <dirent.h>
#include "gtkb2_0.h"
#include "gtkb2_ftexte.h"
/*
 *
 *
 */
void   PRELECT_ALL_FILES(Trf_book *book)
/*
 *    Pre-lecture of all the text files to prepare the formatage
 */
{//    start of PRELECT_ALL_FILES
   int ipage, nbbooks,i,j;
   char anv_file[101];
   FILE *fp_log;
   int ncharl,nlp_max,code_out;
   int ifile_book;

/*
 *    Need to be defined ....
 */
/*	ncharl=46;
	nlp_max=32;*/
        nlp_max=(*(*book).extrm).nline_page ;
        ncharl=(*(*book).extrm).nchar_line;
	code_out=1;
/*
 */
   fp_log = book -> fp_log;
   ipage=1;
   ifile_book = 0;
//   printf("PRELECT_ALL_FILES on purpose enter ifile_book=0 to get nbbooks \n"); 
   KLASK_BOOK(&ifile_book,(*book).pages, anv_file);
   nbbooks=ifile_book;
   printf("book no %d -> last book = %s \n",nbbooks,anv_file);
   fflush(stdout);
   fprintf(fp_log,"book no %d -> last book = %s \n",nbbooks,anv_file);
   PRE_LECT_TXT(anv_file,ncharl,nlp_max,code_out);
/*   printf("After PRE_LECT_TXT for last book book no %d -> last book = %s \n",nbbooks,anv_file);
   fflush(stdout);*/
   if(nbbooks > 1 ){
      for(i=1 ; i < nbbooks ; ++i){
         j=i;
//	 printf("loop book no %d call KLASK_PAGE ",j);
         KLASK_BOOK(&j,(*book).pages,anv_file);
/*       printf("file %d = %s \n",i,anv_file);
         fflush(stdout);*/
         fprintf(fp_log,"file %d = %s \n",i,anv_file);
         PRE_LECT_TXT(anv_file,ncharl,nlp_max,code_out);
      }//for(i=0 ; i < nbpages ; ++i){
   }//if(nb_pages > 1 ){
}//    end of PRELECT_ALL_FILES
/***********************************************************************/
void   KLASK_BOOK(int *jfile_book,char mem_pages[],char anv_file[])
/*
 * This sub is a simplifed version of KLASK_PAJ
 * which overlooks the page number. It assumes ipage=1
 * name of the file where page no= jpage is writtem
 * return file_name = anv_file
 *
 */
{/**   KLASK_PAJ  begins  **/
static int nb_books = -1 ;/* start with value -1 retains its new value*/
int nb0_books,i,j,l;
int n1,n2;// max_pages in book file
/*   printf("entry KLASK_BOOK book_no=%d\n",*jfile_book);
   printf("entry KLASK_BOOK mem_pages=%s \n",mem_pages);*/

   if(nb_books > 0 && *jfile_book > nb_books){
      *jfile_book= *jfile_book-nb_books;
 //     printf("modif 1 nb_pages KLASK_PAJ jpage=%d \n",*jpage);
   }/*if(nb_pages > 0 && *jpage > nb_pages){*/
   /*
    * Here we have the problem of a negative jfile_book. If nb_books
   * has already been determined (nb_books > 0 ) no problem.
   * If not, we have to determine nb_books first
   */
   if( *jfile_book <= 0){   
	   if(nb_books > 0 ){
              *jfile_book = *jfile_book + nb_books;
	   }else{/*    if(nb_pages > 0 ){ */
/*
 *   KLASK_NB_PAJ  is in fact seeking the number of books files
 */
	      KLASK_NB_PAJ(&nb_books, mem_pages,anv_file);
 //  printf("after KLASK_NB_PAJ nb_pages=%d \n",nb_pages);
	      *jfile_book= *jfile_book + nb_books;
	      return;
	   }/*    if(nb_pages > 0 ){ */
  //    printf("modif 2 nb_pages KLASK_PAJ jpage=%d \n",*jpage);
   }/*if( *jpage <= 0){*/
   nb0_books = 0;
   i=0;
   l=strlen(mem_pages);
   n1=-1;
   n2=-1;
   while(i < l && nb0_books < *jfile_book ){
      while(mem_pages[i] == ' ')++i; /* remove preceding blancs */
      j=0;
      while(i < l && mem_pages[i] != ' '){
/**	 printf("i=%d j=%d \n",i,j);  **/
	 anv_file[j]=mem_pages[i];
	 ++j;
	 ++i;
      }/*while(i < 0 && mem_pages[i] != ' '){*/
      anv_file[j]='\0';
      if(j > 0){/* extract number of pages pb  ->    */
	 if(strstr(anv_file,"->") != NULL){
	    /**  here we must extract the numbers n1 and n2 n1->n2 */
	    EXTRACT_2NB(anv_file,&n1,&n2);
	    nb0_books = nb0_books+abs(n2 -n1)+1;
	 }else{/*if(strstr != NULL){ */
	    ++nb0_books;
	 }/*if(strstr != NULL){ */
      }/*if(j > 0){*/
   }/**while(i < l && nb0_books < *jpage ){ **/
   /**  try to compute nb_page **/
/*   while(i < l && mem_pages[i] == ' ')++i;
   if(i >= l)nb_books = nb0_books; *//* adjust value of nb_page which will */
                                  /* be retained  in the subroutine */
/*   printf("KLASK_BOOK anv_file=%s , nb_books=%d nb0_books=%d \n",\
		   anv_file,nb_books,nb0_books);*/
 /*  printf("KLASK_PAJ anv_file=%s , nb_pages=%d nb0_pages=%d \n",\
		   anv_file,nb_pages,nb0_pages);*/
   /**   here we have to treat the case   ->      */
   if(strstr(anv_file,"->") != NULL ){
      CASE_ARROW(anv_file,nb0_books,n1,n2,*jfile_book);
   }//if(strstr(anv_file,"->") != NULL ){
/*   printf("KLASK_BOOK anv_file=%s , nb_books=%d nb0_books=%d \n",\
		   anv_file,nb_books,nb0_books);*/
/*
 *   At that level we have in anv_file the name for the book jfile_book
 */
}/**   KLASK_BOOK  ends  **/
/***********************************************************************/
int  TEST_DSCR_ASSOC_FILE(char *ss,int ncharl, int nlp_max, FILE *fp_dscr)
//              int *trf_format)
/*
 *   Open AND close the DSCR file associated with file whose name 
 *   is into ss
 *   On success it returns 1 if DSCR file not changed, 2 if changed
 *   On failure it returns 0
 *   If the DSCR associated file do not exist it is created
 *   If the DSCR file was created with different ncharl and nlp_max 
 *   values, the DSCR file is created anew.
 *
 */
{//======================================================================
	long int nbytes ;
	char *ss_name,c;
//	long int i, nb_lu ;
	int l,i,j,i2;
//      int trf_format;
	DIR   *dip;
        int code_out ;
	int iback,irep,type,ncharl1,nlp1;

/*
 */
        if((dip = opendir("./DSCR")) == NULL){
	      iback=0;
	      return(iback);
        }//if((dip = opendir("./DSCR")) == NULL){
/*        STAT_FILE_TEXT(fp,&avr,&prob_blanc,&prob_upper,&ftext);
	printf("PRE_LECT_TXT txt formated=%d \n",ftext);
	printf("PRE_LECT_TXT avr=%15.8f  prob_blanc=%15.8f  prob_upper=%15.8f \n",
	       avr,prob_blanc,prob_upper);*/
	l=strlen(ss);
        nbytes = l+50;
	ss_name =  (char *) malloc((nbytes+5)*sizeof(char));
	strcpy(ss_name,"./DSCR/DSCR-");
	i=l-1;
	while(i >= 0 && *(ss+i) == ' ')--i;
	i2= i+1;
	c= *(ss+i);
	while(i >= 0 && c != '/' && c != '\\' && c != ' '){
	   --i;
	   if(i >= 0 )c = *(ss+i);
	}// while ( i >= 0 && c !=
	j=strlen(ss_name);
	++i;
	while(i < i2){
	  *(ss_name + j) = *(ss+i);
	  ++j;
	  ++i;
	}/*while(i < i2){*/
	*(ss_name + j)='\0';
//	printf("sub TEST_DSCR_ASSOC_FILE ss_name=%s\n",ss_name);
	if((fp_dscr = fopen(ss_name,"r")) != NULL){
	   type=-1;
           irep= EXTRACT1_DSCR_ASSOC_FILE(fp_dscr, &type, &ncharl1,&nlp1);
/*	printf("sub TEST_DSCR_ASSOC_FILE ncharl1=%d nlp1=%d type=%d\n ",\
	      ncharl1,nlp1,type);
	printf("sub TEST_DSCR_ASSOC_FILE ncharl=%d nlp_max%d \n ",\
	      ncharl,nlp_max);*/
/*	   if(irep <= 0 ){
	      iback=0;
	      free(ss_name);
	      return(iback);
	   }*///if((fp_dscr = fopen(ss_name,"r")) == NULL){
	   if(type > 3 || ( ncharl1 == ncharl && nlp1 == nlp_max)){
//	      printf("TEST_DSCR_ASSOC_FILE return without close \n");
	      fclose(fp_dscr);
	      free(ss_name);
	      iback=1;
	      return(iback);
	   }//if(type > 3){
/*
 *    close and remove file fp_dscr
 */
	   fclose(fp_dscr);
	   remove(ss_name);
	   code_out=0;
//	printf("sub TEST_DSCR_ASSOC_FILE call PRE_LECT_TXT\n");
           PRE_LECT_TXT(ss,ncharl,nlp_max,code_out);
	   if((fp_dscr = fopen(ss_name,"r")) == NULL){
	      iback=0;
	      free(ss_name);
	      return(iback);
	   }//if((fp_dscr = fopen(ss_name,"r")) == NULL){
	   iback=2;
	   free(ss_name);
	   fclose(fp_dscr);
	   return(iback);
	}else{//if((fp_dscr = fopen(ss_name,"r")) != NULL){
/*	   ncharl=46;
	   nlp_max=32;*/
	   code_out=0;
           PRE_LECT_TXT(ss,ncharl,nlp_max,code_out);
	   if((fp_dscr = fopen(ss_name,"r")) == NULL){
	      iback=0;
	      free(ss_name);
	      return(iback);
	   }//if((fp_dscr = fopen(ss_name,"r")) == NULL){
	   iback=2;
	   free(ss_name);
	   fclose(fp_dscr);
	   return(iback);
	}//if((fp_dscr = fopen(ss_name,"r")) != NULL){
}//=====================================================================
/***********************************************************************/
int  EXTRACT_DSCR_ASSOC_FILE(char *ss, int *jpage,\
        long int li0_extracted[], long int li1_extracted[],\
	      int *type, int *max_pages)
//              int *trf_format)
/*
 *   Open the DSCR file associated with file whose name is
 *   into ss and extract the position of the page ipage
 *   ipage <= 0 if we are looking for the last page of the file
 *
 *   We return also "type" the kind of file we were asking in ss
 *   and max_pages the nb max of pages in this file
 *   On success it returns back = 1 and the position of the 
 *   page  and the character position in 
 *   Start position of page li0_extracted[1] 
 *   start character li0_extracted[2]
 *   For the end of the page :   li1_extracted[1] et li1_extracted[2]
 *   and this for the ending of the page
 *   but li1_extracted[1] = -1 means end of file
 *       li1_extracted[2] = -1 means before position li1_extracted[1]
 *       last charcater of preceding line
 *   On failure it returns back = 0 (if ipage > nb pages max in the file)
 *   it return back = -1 for a true error.
 *
 */
{//======================================================================
	FILE *fp_dscr ;
	long int nbytes ;
	char *ss_name,c,*ssd,*st;
//	long int i, nb_lu ;
	int l,i,j,i2;
//      int trf_format;
	DIR   *dip;
	int iback, i0_extracted[5];
	int i_page,nb_lu,iwalk,ipage ;

/*
 */
        ipage = *jpage;
        li0_extracted[1]= -1;
        li0_extracted[2]= -1;
        li1_extracted[1]= -1;
        li1_extracted[2]= -1;
	*type = -1;
        iback = 0;
        if((dip = opendir("./DSCR")) == NULL){
	   iback = -1;// a true error this sub is to be called after the
	              // creation of the DSCR file !
	   return(iback);
        }//if((dip = opendir("./DSCR")) == NULL){
	l=strlen(ss);
        nbytes = l+50;
	ss_name =  (char *) malloc((nbytes+5)*sizeof(char));
	strcpy(ss_name,"./DSCR/DSCR-");
	i=l-1;
	while(i >= 0 && *(ss+i) == ' ')--i;
	i2= i+1;
	c= *(ss+i);
	while(i >= 0 && c != '/' && c != '\\' && c != ' '){
	   --i;
	   if(i >= 0 )c = *(ss+i);
	}// while ( i >= 0 && c !=
	j=strlen(ss_name);
	++i;
	while(i < i2){
	  *(ss_name + j) = *(ss+i);
	  ++j;
	  ++i;
	}/*while(i < i2){*/
	*(ss_name + j)='\0';
//	printf("sub EXTRACT_DSCR_ASSOC_FILE ss_name=%s\n",ss_name);
	if((fp_dscr = fopen(ss_name,"r")) == NULL){
	   free(ss_name);
	   iback=-1;
	   return(iback);
	}//if((fp_dscr = fopen(ss_name,"r")) == NULL){
        free(ss_name);
/*
 *   Beggin lecture of the file
 */
/*
 *
 */
        nbytes = 100;
	ssd =  (char *) malloc((nbytes+5)*sizeof(char));
	i_page = 0;
	i = 0;
	iback=0;
	while(i < 100000 && ( ipage <= 0 || i_page <= ipage) ){
	   ++i;
	   nb_lu = aln_getline(&ssd,&nbytes,fp_dscr);
	   if(nb_lu == -2 && i_page < ipage){
	      printf("page %d not found in DSCR- file : error\n",ipage);
	      free(ssd);
	      iback = -1;
	      return(iback);
	   }/*if(nb_lu == -2){*/
	   if(ssd[0] == '#')continue;
	   if((st=strstr(ssd,"nlp=")) != NULL)continue;
	   if((st=strstr(ssd,"NB_PAGES=")) != NULL){
	      st = st+9;
              iwalk=EXTR_N_INT(1,st, i0_extracted);
	      if(i0_extracted[0] != 1 ){
	         printf("EXTRACT_DSCR_ASSOC_PAGE error 1 i0[0]=%d  stop 13 \n",\
		 i0_extracted[0]);
		 exit(13);
	      }//if(i0_extracted[0] != 1 ){
	      *max_pages = i0_extracted[1];
	      if(ipage > *max_pages){
	         free(ssd);
		 fclose(fp_dscr);
	         iback=0;
	         return(iback);
	      }//if(ipage > *max_pages){
	      if(ipage <= 0){ // negative ipage means last page
	          ipage=*max_pages ; 
		  *jpage = ipage;
	      }//if(ipage <= 0){
	      continue;
	   }//if((st=strstr(ssd,"NB_PAGES=")) != NULL){
	   if((st=strstr(ssd,"DSCR ")) != NULL){
	      st = st+4;
              iwalk=EXTR_N_INT(1,st, i0_extracted);
	      if(i0_extracted[0] != 1 ){
	         printf("EXTRACT_DSCR_ASSOC_PAGE error 1 i0[0]=%d  stop 13 \n",\
		 i0_extracted[0]);
		 exit(13);
	      }//if(i0_extracted[0] != 1 ){
	      if(i0_extracted[1] > 4 ){
	         printf("EXTRACT_DSCR_ASSOC_PAGE error 1 i0[0]=%d  stop 13 \n",\
		 i0_extracted[1]);
		 exit(14);
	      }//if(i0_extracted[0] != 1 ){
	      *type= i0_extracted[1];
	      continue;
	   }//if((st=strstr(ss,"DSCR ")
	   ++i_page;
	   if(i_page == ipage){
//	      printf("call page %s\n",ss);
//              printf("before EXTRACT_N_LINT ssd=%s\n",ssd);
              iwalk=EXTR_N_LINT(2,ssd, li0_extracted);
	      if(li0_extracted[0] != 2 ){
	         printf("Lect2 page %d error 1  \n",ipage);
		 fclose(fp_dscr);
		 free(ssd);
		 iback=-1;
	         return(iback);
	      }/*if(li_extracted[0] != 2 ){*/
//	      printf("li0_extracted %ld  %ld \n",li0_extracted[1],li0_extracted[2]);
	   }else{/*if(i_page == n_page){*/
              if(i_page == ipage+1){
	         li1_extracted[0]=0;
	         if(nb_lu != -2){
                    iwalk=EXTR_N_LINT(2,ssd, li1_extracted);
	            if(li1_extracted[0] != 2 ){
	               printf("Lect2 page %d error 2  \n",i_page);
		       free(ssd);
		       fclose(fp_dscr);
		       iback=-1;
	               return(iback);
	            }/*if(li_extracted[0] != 2 ){*/
		    li1_extracted[2] = li1_extracted[2]-1;
//	            printf("li1_extracted %ld  %ld \n",li1_extracted[1],li1_extracted[2]);
	         }/*if(nb_lu != -2){*/
              }/*if(i_page == n_page+1){*/
	   }/*if(i_page == n_page){*/

	}/*while(i_page < n_page){*/
//	fclose(fp_dscr);
	free(ssd);
	fclose(fp_dscr);
	iback=1;
	return(iback);
}//=====================================================================
/***********************************************************************/
int  EXTRACT1_DSCR_ASSOC_FILE(FILE *fp_dscr, \
	      int *type, int *ncharl, int *nlp)
//              int *trf_format)
/*
 *   Open the DSCR file associated with a text file
 *   and extract the type, the number of characters by line
 *   and the number of lines by page
 *
 *   On success it returns back = 1  
 *   On failure it returns back = 0 or back = -1 if the dir or file
 *                         does not exist 
 *   it return back = -1 for a true error.
 *
 */
{//======================================================================
	long int nbytes ;
	char *ssd,*st;
//	long int i, nb_lu ;
	int i;
//      int trf_format;
	int iback, i0_extracted[5];
	int i_page,nb_lu,iwalk ;
	long int nc;

/*
 */
//	printf("enter EXTRACT1_DSCR_ASSOC_FILE \n");
	*type = -1;
	*ncharl = -1;
	*nlp = -1;
	nc=0;
	fseek(fp_dscr,nc,0);
/*
 *   Beggin lecture of the file
 */
/*
 *
 */
        nbytes = 100;
	ssd =  (char *) malloc((nbytes+5)*sizeof(char));
	i_page = 0;
	i = 0;
	iback=0;
	while(i < 100000 && i_page == 0  ){
	   ++i;
	   nb_lu = aln_getline(&ssd,&nbytes,fp_dscr);
	   if(nb_lu == -2 ){
	      printf("EXTRACT1_DSCR_ASSOC_FILE error 0 stop 12 \n");
	      free(ssd);
	      iback = -1;
	      return(iback);
	   }/*if(nb_lu == -2){*/
	   if(ssd[0] == '#')continue;
	   if((st=strstr(ssd,"nlp=")) != NULL){
	      st = st+4;
              iwalk=EXTR_N_INT(1,st, i0_extracted);
	      if(i0_extracted[0] != 1 ){
	         printf("EXTRACT1_DSCR_ASSOC_FILE error 1 i0[0]=%d  stop 13 \n",\
		 i0_extracted[0]);
		 exit(13);
	      }//if(i0_extracted[0] != 1 ){
	      *nlp = i0_extracted[1];
//	      printf("EXTRACT1_DSCR_ASSOC_FILE nlp=%d \n",*nlp);
	      if((st=strstr(ssd,"ncharl=")) == NULL){
	         printf("EXTRACT1_DSCR_ASSOC_FILE error 2  stop 14 \n");
		 exit(14);
	      }//if((st=strstr(ssd,"ncharl=")) == NULL){
	      st = st+7;
              iwalk=EXTR_N_INT(1,st, i0_extracted);
	      if(i0_extracted[0] != 1 ){
	         printf("EXTRACT1_DSCR_ASSOC_FILE error 3 i0[0]=%d  stop 15 \n",\
		 i0_extracted[0]);
		 exit(15);
	      }//if(i0_extracted[0] != 1 ){
	      *ncharl = i0_extracted[1];
//	      printf("EXTRACT1_DSCR_ASSOC_FILE ncharl=%d \n",*ncharl);
	      if((st=strstr(ssd,"type=")) == NULL){
	         printf("EXTRACT1_DSCR_ASSOC_FILE error 4  stop 16 \n");
		 exit(16);
	      }//if((st=strstr(ssd,"ncharl=")) == NULL){
	      st = st+5;
              iwalk=EXTR_N_INT(1,st, i0_extracted);
	      if(i0_extracted[0] != 1 ){
	         printf("EXTRACT1_DSCR_ASSOC_FILE error 5 i0[0]=%d  stop 17 \n",\
		 i0_extracted[0]);
		 exit(17);
	      }//if(i0_extracted[0] != 1 ){
	      *type = i0_extracted[1];
//	      printf("EXTRACT1_DSCR_ASSOC_FILE type=%d \n",*type);
	      i_page = 1;
	   }//if((st=strstr(ssd,"nlp=")) != NULL){

	}/*while(i_page == 0){*/
	free(ssd);
//	fclose(fp_dscr);
	nc=0; // positioning at the file beginning
	fseek(fp_dscr,nc,0);
	iback=1;
	return(iback);
}//=====================================================================
/***********************************************************************/
int  EXTRACT1_TXF_ASSOC_FILE(FILE *fp_dscr, int *ncharl, int *nlp)
//              int *trf_format)
/*
 *   Open the TXF file associated with the unformatted text file 
 *   It verify the type .NP, the number of characters by line
 *   and the number of lines by page
 *
 *   On success it returns back = 1  
 *   On failure it returns back = 0 or back = -1 if the dir or file
 *                         does not exist 
 *   it return back = -1 for a true error.
 *
 */
{//======================================================================
	long int nbytes ;
	char *ssd,*st;
//	long int i, nb_lu ;
	int i;
//      int trf_format;
	int iback, i0_extracted[5];
	int i_page,nb_lu,iwalk ;
	long int nc;

/*
 */
//	printf("enter EXTRACT1_TXF_ASSOC_FILE \n");
	*ncharl = -1;
	*nlp = -1;
	nc=0;
	fseek(fp_dscr,nc,0);
/*
 *   Beggin lecture of the file
 */
/*
 *
 */
        nbytes = 100;
	ssd =  (char *) malloc((nbytes+5)*sizeof(char));
	i_page = 0;
	i = 0;
	iback=0;
	while(i < 100000 && i_page == 0  ){
	   ++i;
	   nb_lu = aln_getline(&ssd,&nbytes,fp_dscr);
	   if(nb_lu == -2 ){
	      printf("EXTRACT1_TXF_ASSOC_FILE error 0 stop 12 \n");
	      free(ssd);
	      iback = -1;
	      return(iback);
	   }/*if(nb_lu == -2){*/
	   if((st=strstr(ssd,".NP ")) == NULL)continue;
	   if((st=strstr(ssd,"nlp=")) != NULL){
	      st = st+4;
              iwalk=EXTR_N_INT(1,st, i0_extracted);
	      if(i0_extracted[0] != 1 ){
	         printf("EXTRACT1_TXF_ASSOC_FILE error 1 i0[0]=%d  stop 13 \n",\
		 i0_extracted[0]);
		 exit(13);
	      }//if(i0_extracted[0] != 1 ){
	      *nlp = i0_extracted[1];
//	      printf("EXTRACT1_DSCR_ASSOC_FILE nlp=%d \n",*nlp);
	      if((st=strstr(ssd,"ncharl=")) == NULL){
	         printf("EXTRACT1_TXF_ASSOC_FILE error 2  stop 14 \n");
		 exit(14);
	      }//if((st=strstr(ssd,"ncharl=")) == NULL){
	      st = st+7;
              iwalk=EXTR_N_INT(1,st, i0_extracted);
	      if(i0_extracted[0] != 1 ){
	         printf("EXTRACT1_TXF_ASSOC_FILE error 3 i0[0]=%d  stop 15 \n",\
		 i0_extracted[0]);
		 exit(15);
	      }//if(i0_extracted[0] != 1 ){
	      *ncharl = i0_extracted[1];
//	      printf("EXTRACT1_DSCR_ASSOC_FILE ncharl=%d \n",*ncharl);
	      i_page = 1;
	   }else{//if((st=strstr(ssd,"nlp=")) != NULL){
	      printf("EXTRACT1_TXF_ASSOC_FILE error 4 nlp  stop 16 \n");
	      exit(16);
	   }//if((st=strstr(ssd,"nlp=")) != NULL){

	}/*while(i_page == 0){*/
	free(ssd);
//	fclose(fp_dscr);
	nc=0; // positioning at the file beginning
	fseek(fp_dscr,nc,0);
	iback=1;
	return(iback);
}//=====================================================================
/***********************************************************************/
int  MAX_PAGES_IN_FILE(char *ss)
//              int *trf_format)
/*
 *   Open the DSCR file associated with file whose name is
 *   into ss and extract the number maxi of pages into
 *   this file. If the DSCR file does not exist it will not
 *   create it. It will return -1
 *
 *   max_pages the nb max of pages in this file
 *   On success it returns the number max of pages 
 *
 */
{//======================================================================
	FILE *fp_dscr ;
	long int nbytes ;
	char *ss_name,c,*ssd,*st;
//	long int i, nb_lu ;
	int l,i,j,i2,max_pages;
//      int trf_format;
	DIR   *dip;
	int  i0_extracted[5];
	int nb_lu,iwalk ;

/*
 */
/*        printf("enter MAX_PAGES_IN_FILE ss=%s@@@\n",ss);
	fflush(stdout);*/
        max_pages = -1;
        if((dip = opendir("./DSCR")) == NULL){
	   return(max_pages);
        }//if((dip = opendir("./DSCR")) == NULL){
	l=strlen(ss);
        nbytes = l+50;
	ss_name =  (char *) malloc((nbytes+5)*sizeof(char));
	strcpy(ss_name,"./DSCR/DSCR-");
	i=l-1;
	while(i >= 0 && *(ss+i) == ' ')--i;
	i2= i+1;
	c= *(ss+i);
	while(i >= 0 && c != '/' && c != '\\' && c != ' '){
	   --i;
	   if(i >= 0 )c = *(ss+i);
	}// while ( i >= 0 && c !=
	j=strlen(ss_name);
	++i;
	while(i < i2){
	  *(ss_name + j) = *(ss+i);
	  ++j;
	  ++i;
	}/*while(i < i2){*/
	*(ss_name + j)='\0';
/*	printf("sub MAX_PAGES_IN_FILE ss_name=%s\n",ss_name);
	fflush(stdout);*/
	if((fp_dscr = fopen(ss_name,"r")) == NULL){
	   free(ss_name);
	   return(max_pages);
	}//if((fp_dscr = fopen(ss_name,"r")) == NULL){
        free(ss_name);
/*
 *   Beggin lecture of the file
 */
/*
 *
 */
        nbytes = 100;
	ssd =  (char *) malloc((nbytes+5)*sizeof(char));
	i = 0;
	while(i < 20  ){
	   ++i;
	   nb_lu = aln_getline(&ssd,&nbytes,fp_dscr);
	   if(nb_lu == -2 ){
	      free(ssd);
	      fclose(fp_dscr);
	      return(max_pages);
	   }/*if(nb_lu == -2){*/
	   if(ssd[0] == '#')continue;
	   if((st=strstr(ssd,"NB_PAGES=")) != NULL){
	      st = st+9;
              iwalk=EXTR_N_INT(1,st, i0_extracted);
	      if(i0_extracted[0] != 1 ){
	         printf("EXTRACT_DSCR_ASSOC_PAGE error 1 i0[0]=%d  stop 13 \n",\
		 i0_extracted[0]);
		 exit(13);
	      }//if(i0_extracted[0] != 1 ){
	      max_pages = i0_extracted[1];
	         free(ssd);
		 fclose(fp_dscr);
	         return(max_pages);
	      }//if(ipage > *max_pages){

	}/*while(i_page < n_page){*/
//	fclose(fp_dscr);
	free(ssd);
	fclose(fp_dscr);
	return(max_pages);
}//=====================================================================
/***********************************************************************/
int  PRE_LECT_TXT(char *ss,int ncharl, int nlp_max, int code_out)
//              int *trf_format)
/*
 *    Pre Lecture of a text file whose name is into ss
 *    ncharl = The number of char by lines for TXF-name
 *    nlp_max = The number maxi of lines by page for TXF-name
 *
 *    If the files does not exist or if they are obsolete it :
 *    creates the file ./DSCR/DSCR-name
 *    if code_out = 1 creates the file ./TXF/TXF-name
 *    The file TXF-name is a file of formated text that will be easily
 *    editable by hand.
 *    On output, we have :     trf_format= 1 => unformatted long line
 *                             trf_format= 2 => unformatted short line
 *                             trf_format= 3 => formatted but can be changed
 *                             trf_format= 4 => formatted in form of origin
 *
 */
{
	FILE *fp, *fp_out, *fp_dscr;
	long int nbytes ;
	char *ss_name,*ss_nameo,c;
//	long int i, nb_lu ;
	int n_line,pre;
	int ftext,i_dscr,i_txf;
	int l,i,i0,j,i2;
//      int trf_format;
	double avr,prob_blanc,prob_upper;
	double dft;
	DIR   *dip;

/*
 */
        if((dip = opendir("./DSCR")) == NULL){
	   printf("Create directory DSCR \n");
	   system("mkdir DSCR");
        }//if((dip = opendir("./DSCR")) == NULL){
	pre = 0;
	fp= fopen(ss,"r");
	if(fp == NULL){
	  printf("file %s not found\n",ss);
	  return(pre);
	}/*if(fp == NULL){*/
/*        STAT_FILE_TEXT(fp,&avr,&prob_blanc,&prob_upper,&ftext);
	printf("PRE_LECT_TXT txt formated=%d \n",ftext);
	printf("PRE_LECT_TXT avr=%15.8f  prob_blanc=%15.8f  prob_upper=%15.8f \n",
	       avr,prob_blanc,prob_upper);*/
	l=strlen(ss);
        nbytes = l+50;
	ss_name =  (char *) malloc((nbytes+5)*sizeof(char));
	ss_nameo =  (char *) malloc((nbytes+5)*sizeof(char));
	strcpy(ss_name,"./DSCR/DSCR-");
	i=l-1;
	while(i >= 0 && *(ss+i) == ' ')--i;
	i2= i+1;
	c= *(ss+i);
	while(i >= 0 && c != '/' && c != '\\' && c != ' '){
	   --i;
	   if(i >= 0 )c = *(ss+i);
	}// while ( i >= 0 && c !=
	j=strlen(ss_name);
	++i;
	i0=i;
	while(i < i2){
	  *(ss_name + j) = *(ss+i);
	  ++j;
	  ++i;
	}/*while(i < i2){*/
	*(ss_name + j)='\0';
//	printf("sub PRE_LECT_TEXT ss_name=%s\n",ss_name);
	i_dscr=0;
	if((fp_dscr = fopen(ss_name,"r")) != NULL){
	   fclose(fp_dscr);
	   dft=DIFF_TIME_FILE(ss  , ss_name);
	   if(dft <= 0 )i_dscr=1;
	}else{//if((fp_dscr = fopen(ss_name,"r")) != NULL){
	   i_dscr=1;
	}//if((fp_dscr = fopen(ss_name,"r")) != NULL){

/*	ncharl=46;
	nlp_max=32;*/

//	code_out=1;
        i_txf=0;
	strcpy(ss_nameo," ");
        if(code_out == 1){
           if((dip = opendir("./TXF")) == NULL){
	      printf("Create directory TXF \n");
	      system("mkdir TXF");
           }//if((dip = opendir("./TXF")) == NULL){
	   strcpy(ss_nameo,"./TXF/TXF-");
	   j=strlen(ss_nameo);
	   i=i0;
	   while(i < i2){
	     *(ss_nameo + j) = *(ss+i);
	     ++j;
	     ++i;
	   }/*while(i < i2){*/
	   *(ss_nameo + j)='\0';
	   if((fp_out = fopen(ss_nameo,"r")) != NULL){
	      fclose(fp_out);
	      dft=DIFF_TIME_FILE(ss  , ss_name);
	      if(dft <= 0 || i_dscr == 1)i_txf=1;
	   }else{//if((fp_dscr = fopen(ss_name,"r")) != NULL){
	      i_txf=1;
	   }//if((fp_dscr = fopen(ss_name,"r")) != NULL){
//	   printf("sub PRE_LECT_TEXT ftext=%d ss_txt=%s\n",ftext,ss_name);
	   if(i_txf == 0){
	      code_out=0;
	   }else{//if(i_txf == 0){
              fp_out = fopen(ss_nameo,"w+") ;
	   }//if(i_txf == 0){
        }//if(code_out == 1){
/*
 * NOW we have the writing of the files
 */
	if(i_dscr == 1  || code_out != 0){
//	   printf("PRE_LECT_TXT call STAT_FILE_TEXT for %s \n",ss);
           STAT_FILE_TEXT(fp,&avr,&prob_blanc,&prob_upper,&ftext);
/*
 *           ftext = 0  if unformated text
 *           ftext = 1  if text = formated text
 *           ftext = 2  if text = formated in the original form (not to be
 *                                                            changed)
 */
/*	   printf("PRE_LECT_TXT txt formated=%d \n",ftext);
	   printf("PRE_LECT_TXT avr=%15.8f  prob_blanc=%15.8f  prob_upper=%15.8f \n",
	       avr,prob_blanc,prob_upper);*/
           fp_dscr = fopen(ss_name,"w+") ;
	}else{//if(i_dscr == 1  || code_out != 0){
	   free(ss_name);
	   free(ss_nameo);
	   return(pre);
	}//if(i_dscr == 1  || code_out != 0){
/*	printf("sub PRE_LECT_TXT ecriture fichier ss_name=%s\n",ss_name);
	printf("sub PRE_LECT_TXT ecriture fichier ss_nameo=%s\n",ss_nameo);*/
	free(ss_name);
	free(ss_nameo);
	if(ftext == 0){
	   if(avr <= 120){
              n_line =  DSCR2_FILE_TEXT(fp,fp_dscr,ncharl,nlp_max,\
	             code_out,fp_out);
	      pre=2;
//	      trf_format = 2;
	   }else{//if(avr <= 100){
              n_line =  DSCR1_FILE_TEXT(fp,fp_dscr,ncharl,nlp_max,\
	             code_out,fp_out);
	      pre=1;
//	      trf_format = 1;
	   }//if(avr <= 100){
	}else{//if(ftext == 0){
	   if(ftext != 1 && ftext != 2){
	      printf("PRE_LECT_TXT Error ftext  return");
	      fclose(fp_dscr);
	      fclose(fp);
	      return(pre);
	   }//if(ftext != 1 && ftext != 2){
           n_line =  DSCR3_FILE_TEXT(ftext,fp,fp_dscr,ncharl,nlp_max);
	   pre=ftext+2;
//	   trf_format = ftext+2;
	}//if(ftext == 0){
//	printf("after DSCR2_FILE_TEXT n_line=%d \n",n_line);
	if(code_out == 1)fclose(fp_out);
	fclose(fp_dscr);
	fclose(fp);
//	pre=1;
	return(pre);
/*
 */
} //* end of int  PRE_LECT_TXT(char *ss)

/**********************************************************************/
void  STAT_FILE_TEXT(FILE *fp,double *avr,double *prob_blanc,\
       double *prob_upper, int *ftext)
/*
 *    Goal : to generate statistics for a text file
 *           avr un charactere appartient en moyenne a une ligne de 
 *           longueur avr
 *           prob_blanc x% des lignes commencent par des charactere blancs
 *           prob_upper x% des lignes commencent par une majuscule
 *           ftext = 0  if unformated text
 *           ftext = 1  if text = formated text
 *           ftext = 2  if text = formated in the original form (not to be
 *                                                            changed)
 */
{/*  start of STAT_FILE_TEXT    */ 
   long int i,j,ss_pos,nb_lu,nbytes;
   long int tot_blanc,tot_nblanc,tot_upper;
   int lb,n_line;
   char *ss,*st,*sh;
   double tot1,prob_nblanc;
   long int tot_n;
        nbytes = 100;
	ss =  (char *) malloc((nbytes+5)*sizeof(char));
/***********/
	i = 0;
	lb=0;/*  blanc lines */
//	nc=70;
        n_line=0;
	ss_pos=0;
	tot1=0.e+00;
	tot_n=0;
	tot_blanc=0;
	tot_nblanc=0;
	tot_upper=0;
	*ftext=0;
	while(i < 100000 && ( nb_lu = aln_getline(&ss,&nbytes,fp)) != -2 ){
//	   printf("STAT_FILE_TEXT i=%ld ss=%s \n",i,ss);
	   if(i == 0){
	      st= strstr(ss,".NP");
	      sh= strstr(ss,".NH");
	      if(st != NULL || sh != NULL)*ftext = 1;
	      if(*ftext != 0){
	         st= strstr(ss,".NPO");
	         sh= strstr(ss,".NHO");
	         if(st != NULL || sh != NULL)*ftext = 2;
	      }/*if(*ftext == 0){*/
	   }/*if(i == 0){*/
//	   printf("Sub STAT_FILE_TEXT   ftext=%d \n",*ftext);
	   if(nb_lu > 0){
	      tot_n=tot_n+nb_lu;
	      tot1 = tot1+nb_lu*nb_lu;
	      if(ss[0] == ' '){
	         tot_blanc=tot_blanc+nb_lu;
	      }else{/*if(ss[0] == ' '){*/
	         tot_nblanc=tot_nblanc+nb_lu;
	      }/*if(ss[0] == ' '){*/
	      j=0;
	      while(j < nb_lu && ss[j] == ' ')++j;
	      if(isupper(ss[j]))tot_upper=tot_upper+nb_lu;
	   }/*if(nb_lu > 0){*/
/*           OUT_STRING (ss_pos, ss,ncharl,&lb,&n_line,nlp_max, \
	               code_out,fp_out,fp_dscr ); */
//	   fprintf(fp_dscr,"i=%ld n_line=%d \n",i,n_line);
	   ++i;
	}/*while(getline(&ss,&nbytes,fp) != -1 ){*/
	printf("formated text = %d \n",*ftext);
	*avr = tot1/tot_n;
	*prob_blanc=100.e+00*tot_blanc/tot_n;
	prob_nblanc=100.e+00*tot_nblanc/tot_n;
	printf("on average each char is on a line of length %15.8f \n",*avr);
	printf("proba for a char to be on a line begining by a blanc %15.8f percent \n",*prob_blanc);
	printf("proba for a char to be on a line not begining by a blanc %15.8f percent\n",prob_nblanc);
	*prob_upper=100.e+00*tot_upper/tot_n;
	printf("proba for a char to be on a line begining by a capital char %15.8f percent\n",*prob_upper);
}/*  end of STAT_FILE_TEXT    */ 
/**********************************************************************/
int  DSCR1_FILE_TEXT(FILE *fp,FILE *fp_dscr,int ncharl,int nlp_max,\
     int code_out,FILE *fp_out)
/*
 *    Goal : to generate the DSCR file of a .txt file
 *    which originally was not formatted
 *    Optionally if code_out = 1 it will generate a copy of the
 *    original .txt file with jump page indications .NP
 *    This sub DSCR1_  is for the description of a file with
 *    lengths as long as paragraphs.
 */
{/*  start of DSCR1_FILE_TEXT    */ 
   long int i,ss_pos,nb_lu,nbytes,nc,nc0,lss;
   int lb,n_line,nb_pages,l,ncr2;
   char *ss;
	ncr2=ncharl+ncharl;
//        printf("enter DSCR1_FILE_TEXT code_out=%d \n",code_out);
        nbytes = 100;
	ss =  (char *) malloc((nbytes+5)*sizeof(char));
/***********/
	i = 0;
	fprintf(fp_dscr,"#  pos_ss   start_char\n");
	lb=0;/*  blanc lines */
	fprintf(fp_dscr,"  nlp=%d  ncharl=%d  type=1 \n",nlp_max,ncharl);
	nc0 = ftell(fp_dscr);
	fprintf(fp_dscr,"#  NB_PAGES= xxxxxxxxxx\n");
	fprintf(fp_dscr,"# DSCR 1 = long length for the input lines\n");
	fprintf(fp_dscr,"# DSCR 2 = short length for the input lines\n");
	fprintf(fp_dscr,"# DSCR 3 = already formated text\n");
	fprintf(fp_dscr,"# DSCR 4 = text given into the original format\n");
	fprintf(fp_dscr," DSCR 1 = long length for the input lines\n");
//	nc=70;
        nb_pages=0;
        n_line=0;
	ss_pos=0;
        nc = 0;
        if(fseek(fp,nc,0) != 0){/** This an error of lecture **/
           printf("DSCR1_FILE_TEXT error start of lecture for file fp \n");
	   return(n_line);
        }/*if(fseek(fp,nc,0) != 0){**/
	while(i < 100000 && ( nb_lu = aln_getline(&ss,&nbytes,fp)) != -2 ){
	   if(nb_lu <= 0)continue;
	   if(n_line == 0){
//	      fprintf(fp_dscr,"i=%ld ss_pos=%ld  i+j=0 \n",i,ss_pos);
	      if(i == 0 && code_out == 1){
	         fprintf(fp_out,".NP  nlp=%d  ncharl=%d\n",nlp_max,ncharl);
	      }/*if(i == 0){*/
	      fprintf(fp_dscr,"%ld  0 \n",ss_pos);
	   }/*if(n_line == 0){*/
	   DECODE_ACCENTS(ss);
	   lss=strlen(ss);
           OUT_STRING (ss_pos, ss,ncharl,&lb,&n_line,nlp_max, \
	               code_out,&nb_pages,fp_out,fp_dscr ); 
//	   fprintf(fp_dscr,"i=%ld n_line=%d \n",i,n_line);
/*
 *    If lss great enough, we write a white line as a separation 
 *    between paragraphs;
 */
	   if(n_line != 0 && n_line < nlp_max && lss > ncr2 && lb < 2){
	      if(code_out == 1)fprintf(fp_out," \n");
	      ++lb;
	      ++n_line;
	   }//if(n_line != 0 && n_line < nlp_max){
	   ss_pos=ftell(fp);
	   ++i;
	}/*while(getline(&ss,&nbytes,fp) != -1 ){*/
	if(n_line > 0 && n_line < nlp_max)++nb_pages;
        if(fseek(fp_dscr,nc0,0) != 0){/** This an error of lecture **/
           printf("DSCR1_FILE_TEXT error start of lecture for file fp_dscr \n");
	   return(n_line);
        }/*if(fseek(fp,nc,0) != 0){**/
	sprintf(ss,"   NB_PAGES= %d",nb_pages);
	l=strlen(ss);
	if(l < 23 ){
	   for(i = l ; i < 23 ; ++i)ss[i]=' ';
	}//if(l < 23 ){
	ss[23]= '\0';
	fprintf(fp_dscr,"%s\n",ss);
        return(n_line);
}/*  end of DSCR1_FILE_TEXT    */ 
/**********************************************************************/
int  DSCR2_FILE_TEXT(FILE *fp,FILE *fp_dscr,int ncharl,int nlp_max,\
     int code_out,FILE *fp_out)
/*
 *    Goal : to generate the DSCR file of a .txt file
 *    which originally was not formatted
 *    Optionally if code_out = 1 it will generate a copy of the
 *    original .txt file with jump page indications .NP
 *    This sub DSCR2_  is for the description of a file with short
 *    line lengths. Paragrahs may be longer than one line.
 */
{/*  start of DSCR2_FILE_TEXT    */ 
   long int i,ss_pos,nb_lu,nbytes,nc,nc00;
   int l,lb,n_line,nc0,nb_pages;
   char *ss;
//        printf("enter DSCR2_FILE_TEXT code_out=%d \n",code_out);
        nbytes = 100;
	ss =  (char *) malloc((nbytes+5)*sizeof(char));
/***********/
	i = 0;
	fprintf(fp_dscr,"#  pos_ss   start_char\n");
	lb=0;/*  blanc lines */
	fprintf(fp_dscr,"  nlp=%d  ncharl=%d  type=2 \n",nlp_max,ncharl);
	nc00 = ftell(fp_dscr);
	fprintf(fp_dscr,"#  NB_PAGES= xxxxxxxxxx\n");
	fprintf(fp_dscr,"# DSCR 1 = long length for the input lines\n");
	fprintf(fp_dscr,"# DSCR 2 = short length for the input lines\n");
	fprintf(fp_dscr,"# DSCR 3 = already formated text\n");
	fprintf(fp_dscr,"# DSCR 4 = text given into the original format\n");
	fprintf(fp_dscr," DSCR 2 = short length for the input lines\n");

//	nc=70;
	nb_pages = 0;
        n_line=0;
	ss_pos=0;
        nc = 0;
        nc0 = 0;
        if(fseek(fp,nc,0) != 0){/** This an error of lecture **/
           printf("DSCR2_FILE_TEXT error start of lecture for file fp \n");
	   return(n_line);
        }/*if(fseek(fp,nc,0) != 0){**/
	while(i < 100000 && ( nb_lu = aln_getline(&ss,&nbytes,fp)) != -2 ){
	   if(n_line == 0){
//	      fprintf(fp_dscr,"i=%ld ss_pos=%ld  i+j=0 \n",i,ss_pos);
	      if(i == 0 ){
	         if(code_out == 1)fprintf(fp_out,".NP  nlp=%d  ncharl=%d\n",nlp_max,ncharl);
	         fprintf(fp_dscr,"%ld  0 \n",ss_pos);
		 ++nb_pages;
	      }/*if(i == 0){*/
	   }/*if(n_line == 0){*/
	   if(lb > 0)nc0=-1;// for a new paragraph
	   DECODE_ACCENTS(ss);
           OUT1_STRING (ss_pos, ss,&nc0,ncharl,&lb,&n_line,nlp_max, \
	               code_out,&nb_pages,fp_out,fp_dscr ); 
//	   fprintf(fp_dscr,"i=%ld n_line=%d \n",i,n_line);
	   ss_pos=ftell(fp);
	   ++i;
	}/*while(getline(&ss,&nbytes,fp) != -1 ){*/
//	if(n_line > 0 && n_line < nlp_max)++nb_pages;
        if(fseek(fp_dscr,nc00,0) != 0){/** This an error of lecture **/
           printf("DSCR1_FILE_TEXT error start of lecture for file fp_dscr \n");
	   return(n_line);
        }/*if(fseek(fp,nc,0) != 0){**/
	sprintf(ss,"   NB_PAGES= %d",nb_pages);
//        printf("DSCR2_FILE_TEXT nb_pages=%d \n",nb_pages);
	l=strlen(ss);
	if(l < 23 ){
	   for(i = l ; i < 23 ; ++i)ss[i]=' ';
	}//if(l < 23 ){
	ss[23]= '\0';
	fprintf(fp_dscr,"%s\n",ss);
        return(n_line);
}/*  end of DSCR2_FILE_TEXT    */ 
/**********************************************************************/
int  DSCR3_FILE_TEXT(int ftext,FILE *fp,FILE *fp_dscr,int ncharl,int nlp_max)
/*
 *    Goal : to generate the DSCR file of a .txt file
 *    This sub DSCR3_  is for the description of a formated file
 */
{/*  start of DSCR3_FILE_TEXT    */ 
   long int i,j,k,ss_pos,nb_lu,nbytes,nc,nc00;
   int l,lb,n_line,nb_pages;
   char *ss,*scar,*scah;
//        printf("Enter DSCR3_FILE_TEXT ftext=%d \n",ftext);
        nbytes = 100;
	ss =  (char *) malloc((nbytes+5)*sizeof(char));
/***********/
	i = 0;
	fprintf(fp_dscr,"#  pos_ss   start_char\n");
	lb=0;/*  blanc lines */
	fprintf(fp_dscr,"  nlp=%d  ncharl=%d  type=3 \n",nlp_max,ncharl);
	if(ftext == 1){
	  fprintf(fp_dscr,"  nlp=%d  ncharl=%d  type=3 \n",nlp_max,ncharl);
	}else{ //if(ftext == 1){
	  fprintf(fp_dscr,"  nlp=%d  ncharl=%d  type=4 \n",nlp_max,ncharl);
	} //if(ftext == 1){
	nc00 = ftell(fp_dscr);
	fprintf(fp_dscr,"#  NB_PAGES= xxxxxxxxxx\n");
	fprintf(fp_dscr,"# DSCR 1 = long length for the input lines\n");
	fprintf(fp_dscr,"# DSCR 2 = short length for the input lines\n");
	fprintf(fp_dscr,"# DSCR 3 = already formated text\n");
	fprintf(fp_dscr,"# DSCR 4 = text given into the original format\n");
	if(ftext == 1){
	  fprintf(fp_dscr," DSCR 3 = already formated text\n");
	}else{ //if(ftext == 1){
	  fprintf(fp_dscr," DSCR 4 = text given into the original format\n");
	} //if(ftext == 1){
//	nc=70;
        n_line=1;
	nb_pages = 0;
	ss_pos=0;
        nc = 0;
        if(fseek(fp,nc,0) != 0){/** This an error of lecture **/
           printf("DSCR3_FILE_TEXT error start of lecture for file fp \n");
	   return(i);
        }/*if(fseek(fp,nc,0) != 0){**/
	while(i < 100000 && ( nb_lu = aln_getline(&ss,&nbytes,fp)) != -2 ){
	   ss_pos=ftell(fp);
	   n_line=1;
	   scar = NULL;
	   scar = strstr(ss,".NP");
	   scah = strstr(ss,".NH");
//	   printf("i=%ld ss=%s@@@ \n",i,ss);
	   if(scar != NULL || scah != NULL){
//	      printf("OK scar scah \n");
	      ++nb_pages;
	      j = scar-ss -1  ;
	      n_line = 0;
	      if(j > 0){
	         k = 0;
	         while(n_line == 0 && k <= j){
		    if(*(ss+k) != ' ')n_line=1;
		    ++k;
	         }//while(n_line == 0 && i <= j){
	      }//if(j > 0){
	   }//if(scar != NULL){
	   if(n_line == 0){
//	      fprintf(fp_dscr,"i=%ld ss_pos=%ld  i+j=0 \n",i,ss_pos);
	      fprintf(fp_dscr,"%ld  0 \n",ss_pos);
	   }/*if(n_line == 0){*/
//	   fprintf(fp_dscr,"i=%ld n_line=%d \n",i,n_line);
	   ++i;
	}/*while(getline(&ss,&nbytes,fp) != -1 ){*/
        if(fseek(fp_dscr,nc00,0) != 0){/** This an error of lecture **/
           printf("DSCR3_FILE_TEXT error start of lecture for file fp_dscr \n");
	   return(n_line);
        }/*if(fseek(fp,nc,0) != 0){**/
//        printf("DSCR3_FILE_TEXT nb_pages=%d \n",nb_pages);
	sprintf(ss,"   NB_PAGES= %d",nb_pages);
	l=strlen(ss);
	if(l < 23 ){
	   for(i = l ; i < 23 ; ++i)ss[i]=' ';
	}//if(l < 23 ){
	ss[23]= '\0';
	fprintf(fp_dscr,"%s\n",ss);
        return(i);
}/*  end of DSCR3_FILE_TEXT    */ 

/**********************************************************************/
long int aln_getline(char **ss,long int *nbytes, FILE *fp)
/*
 *    returns -2 if EOF
 *    returns tro the number of characters which are in the line
 *    *(*ss+tro)= '\0';
 */
{/*=======================================================*/
char c;
long int tro,i, n;
/*   printf("enter aln_getline \n");
   fflush(stdout);*/
   tro=-1;
   c=fgetc(fp);
   if(c == EOF){
      **ss = '\0';
      tro = -2;
      return(tro);
   }/*if(c == EOF){*/
   i = 0;
//   while(c != '\0' && c != EOF && c != '\n' && c != NULL){
   while(c != '\0' && c != EOF && c != '\n' ){
      if(c != 13) {
         *(*ss+i) = c;
         ++i;
      }/*if(c != 13) {*/
      if(i >= *nbytes){
         *nbytes = *nbytes + 100;
	 n= *nbytes+5;
//	 printf("realloc *nbytes=%ld n=%ld \n",*nbytes,n);

	 *ss = realloc(*ss, n*sizeof(char));
      }/*if(i >= nbytes){*/
      c=fgetc(fp);
   }/*while(c != '\0' && c != EOF ){*/
   tro = i ;
   *(*ss+i)= '\0';
//   printf("aln_getline tro=%ld ss=%s@@@ \n",tro,*ss);
   return(tro);
}/*=======================================================*/
/**********************************************************************/
void OUT_STRING ( long int pos_s, char *s,int nc,int *lb,int *n_line,\
      int nlp_max,int code_out, int *nb_pages,FILE *fp_out, FILE *fp_dscr) 
/*
 *    Writing of the character string s in lines of nc characters long
 *    we count also lb the number of blanc lines 
 *    and n_line the number of lines already written
 *    We want pages of nlp_max lines of nc characters long.
 *    fp_out is a file of formated text that will be written if code_out=1
 *    fp_dscr is the description of the original file (we do it)
 *    pos_s is the position of the string s in the original file. This
 *    value is necessary for the writing of the file fp_dscr
 *    This subroutine should be kept in phase with OUT_STRING_BOOK2
 */
{   /****  ==================================    */
char  BFE,c   ;
long nc1,nc2   ;
int i,j,jmem,j1,k,l,ic,nc0 ;
int ncm,ncr,nccm,lstop,jback,iup;
int iwhite_line;
/*fp = fopen("dicovb","r") ;*/
/*fp = fopen(inFile,"r") ;
fpi = fopen("./ww_net","w+") ;*/
/*********************************************************/
//nc = 70 ;
//nc=nc+2;
if(nc < 20 )nc=20;
nc1=nc; //because we start a new paragraph ????
nc2=nc+nc;
//ncm=nc-20;
//if(ncm < 25)ncm=25;
ncm = 25 ; /*** maximum of backward search for a blanc ****/
ncr=40 ; /**  maximum number of reapeated character  **/
i=0 ;
BFE = 'E';

if (s != NULL  ) {
	l=strlen(s);
	if(l <= 0)return;
/*
 *    Case we have a white line
 */
           iwhite_line=1;
           if(l > 0 ) {
               j=0;
               while(iwhite_line == 1 && j < l){
                  c= s[j];
                  ic=c;
                  if(c != ' ' && c !='|' && ic != -96 && ic != 160  )iwhite_line = 0;
                  ++j;
               }//while(iwhite_line == 0 & i < l){
            }//if(l > 0 ) {
	if( iwhite_line == 1) {
		 *lb = *lb+1;
//	         printf("OUTPUT l<= 0  *lb=%d \n",*lb);
		 if(*lb < 3){
	            *n_line = *n_line+1;
		    if(*n_line >= nlp_max){
	              if(code_out == 1) fprintf(fp_out,".NP \n");
		       *lb=0;
		       *n_line = 0;
		       *nb_pages = *nb_pages + 1;
		    }else{/*if(*n_line >= nlp_max){*/
		       if(code_out == 1)fprintf(fp_out,"\n");
		    }/*if(*n_line >= nlp_max){*/
		 }/*if(*lb < 3){*/
	   return;
	}/* if(l <= 0) {*/
/*	printf("\n");
	printf("enter OUTPUT s=%s@@@@ \n",s);*/
	k=0;
	while(s[k] == ' ' && k < l )++k;
	i= k ;
/*
 *    Problem of a line beginning by the same character reapeated
 *    more than ncr times
 */
        c= s[i];
        while(k < l && s[k]== c )++k;
	if((k-i) >= ncr){/*  use that line as a separation */
	  j=k;
	  if(j > i+nc ) j=i+nc;
	  s[j]='\0';
	  *n_line = *n_line+1;
	  if(code_out == 1) fprintf(fp_out,"%s\n",s+i);
          if(*n_line >= nlp_max){
	     if(code_out == 1)fprintf(fp_out,".NP \n");
	     fprintf(fp_dscr,"%ld %d\n",pos_s,k);
             *n_line = 0;
	     *nb_pages = *nb_pages + 1;
	  }/*if(*n_line >= nlp_max){*/
//	  fprintf(fp_out,"%s\n",s+i);
	  *lb=0;
	  s[j]=c;
	  if(k >= l)return;
	  i=k;
	}/*if((k-i) >= ncr){*/
/*
 *     end of repeated char
 */
	lstop = 0 ;
	while(lstop == 0){
//	   printf("OUT_STRING loop lstop level 0  s[%d]=%s@@@\n",i,s+i);
	   j = 0 ;
/*	   BFE='|';
	   printf("s[i]=%c  = %d  BFE=%d \n",s[i],s[i],BFE);*/
//	   while (c = s[i+j] && j < n1 && (SPE_ALPHA_NUM(s[i+j]) )++j;
           c= s[i+j];
	   ic=c;
//	   if(ic == -96 || ic == 160 || iscntrl(c)){
	   if(ic == -96 || ic == 160 ){
	      c=' ';
	      s[i+j]=c;
	      ic=c;
	   }/*if(ic == -96 || ic == 160){*/
	   nc0=0;
	   if(i==0 ) nc0=6;
/*         printf("level -1  l=%d  nc2-nc1-nc0=%ld \n",l,nc2-nc1-nc0);
           printf("level -1.1  nc0=%d nc1=%ld nc2=%ld \n",nc0,nc1,nc2);
	   printf("level -1.2 s[i]=%s@@@ \n",(s+i));*/
	   nccm=nc2-nc1-nc0;
//	   while ( i+j < l && j < nccm && (SPE_ALPHA_NUM(c) || c == ' ' || ispunct(c) )){
	   while ( i+j < l && j < nccm && (SPE_ALPHA_NUM(c) || SPE_PUNCTU(c))){
	      ++j;
              c= s[i+j];
	      ic=c;
/*	      printf("j=%d c=%c ic=%d TRUE_SPN=%d TRUE_ispunct=%d\n",j,c,ic,\
	         (SPE_ALPHA_NUM(c)  ),ispunct(c)  );*/
//	         (SPE_ALPHA_NUM(c) || c == ' ' || ispunct(c) )  );
	      if(ic == -96 || ic == 160 ){
	         c=' ';
	         s[i+j]=c;
	         ic=c;
	      }/*if(ic == -96 || ic == 160){*/
	   }/*while ( j < n1 && (SPE_ALPHA_NUM(c) ||*/
	   k=i;
	   while(k < l && s[k] == ' ')++k;
//	   printf("OUT_STRING loop lstop level 1 write s from k=%d to j=%d \n",k,j);
	   if(s[i+j] == '\0' ){
/*	    printf(" OUTPUT fin ligne i=%d j=%d k = %d\n",i,j,k); 
	      printf("OUTPUT s=%s@@@ \n",s+i);*/
	      --j;
	      while(s[i+j] == ' ')--j;
	      if(strcspn(s+k," ")){/** if that case we have non space char */
//	         printf("OUTPUT autre que blancs \n");
		 if(nc  == nc1){
	            *n_line = *n_line+1;
	            if(code_out == 1) fprintf(fp_out,"%s\n",s+k);
		    if(*n_line >= nlp_max){
	               if(code_out == 1)fprintf(fp_out,".NP \n");
		       *n_line = 0;
		       *nb_pages = *nb_pages + 1;
		    }/*if(*n_line >= nlp_max){*/
		 }else{/*if(nc  == nc1){*/
	            *n_line = *n_line+1;
	            if(code_out == 1)fprintf(fp_out,"  %s\n",s+k);
		    nc1=nc;
		    if(*n_line >= nlp_max){
	               if(code_out == 1) fprintf(fp_out,".NP \n");
		       *n_line = 0;
		       *nb_pages = *nb_pages + 1;
		    }/*if(*n_line >= nlp_max){*/
		 }/*if(nc  == nc1){*/
		 *lb = 0 ;
	      }else{//if(strcspn(s+k,' ')){
		 *lb = *lb+1;
//	         printf("OUTPUT rien que blancs lb=%d \n",*lb);
		 if(*lb < 3){
	            *n_line = *n_line+1;
		    if(*n_line >= nlp_max){
	                if(code_out == 1) fprintf(fp_out,".NP \n");
		       *lb=0;
		       *n_line = 0;
		       *nb_pages = *nb_pages + 1;
		    }else{/*if(*n_line >= nlp_max){*/
		       if(code_out == 1)fprintf(fp_out,"\n");
		    }/*if(*n_line >= nlp_max){*/
		 }/*if(*lb < 3){*/
		 if(nc1 != nc)nc1=nc;
	      }//if(strcspn(s+k,' ')){
		 lstop=1;
	   }else{ /* if(s[i+j] == '\0'){*/
/******   Start of : We are not at the end of the string s      */
//	      if(ic == -96 || ic == 160 || iscntrl(c)){
	      if(ic == -96 || ic == 160 ){//trial 23-01-2008
	         s[i+j]=' ';
//		 --j;
	      }/*if(iscntrl(s[i+j])){*/
//1-Dec-2006  while(s[i+j] != ' ' && j >= ncm)--j;/*look for first blanc*/
	      jback=0;
	      c= s[i+j];
//	      printf("Look for first backward blanc s[i+j]=%c ",s[i+j]);
	      if(j >= nccm){
	      jmem=j;
	      while(j >= 0 && c != ' ' && c != '/' && c != '\\' && jback  <= ncm){
	          --j;/*look for first blanc*/
		  c = s[i+j];
		  ++jback;
	      }/*   end of while(j > 0  */
	      if(j <=0 && jmem > 0)j=jmem;
	      }//if(j >= nccm){
/*	      while(j > nc)--j;
              c=s[i+j];
	      while(c != ' ' && c != '/' && c != 92 && !ispunct(c) && j >= ncm){
	         --j;
                 c=s[i+j];
	      }*//*while(c != ' ' && j >= ncm){*/
	      j1= i+j;
	      c = s[j1];
	      ic = c;
//              while(j >= 0 && (c == ' ' || c == '<' || ic == 34 || ic == 39 ||
              while(j > 1 && (c == ' ' || OPEN_PAR(c) || ic == 34 || ic == 39 ||\
	       ic == 171 || ic == 173 || ic == 151 || c == '-')){
	         --j;
	         j1= i+j;
	         c = s[j1];
	         ic = c;
	      }
	      ++j ; //  ????????
	      j1 = i+j+1;
	      c = s[j1];  
	      ic = c;
//	      printf("OUTPUT after first blanc ligne %d  j1=%d c=%c ic=%d \n",*n_line,j1,c,ic);
/*	      if(s[i+j] == ' ' && ispunct(c) && c != '<' && ic != 38 \
	        && ic != 114 && ic != 171 && c != '(' )j= j1+1;*/
	      iup=0;
	      if(s[i+j] == ' '){
	         while( j1 < l && ispunct(c) && !OPEN_PAR(c) && \
		 !(ic == 34 && iup== 0) && !(ic == 39 && iup == 0)\
	          && ic != 171 && ic != 173 && ic != 151 && c != '-' ){
		    ++j1;
		    ++iup;
	            c = s[j1];
	            ic = c;
	         }//*while( ispunct(c) && c != '<' && ic != 38 
		 j=j1-i;
	      }else{/*if(s[i+j] == ' '){*/
// modif april 30 2007  
	         ic=s[i+j];
		 c=s[i+j-1];
		 if( ispunct(s[i+j]) && (isalnum(c) || c == ' '))++j;
	      }/*if(s[i+j] == ' '){*/
// 1-Dec-2006 j=j1-i;
	      if(j <= 0 )j=1;
	      BFE = s[i+j];
	      s[i+j] = '\0';
//	      printf("ADD to line =%s@@@@\n",s+i);
//	      fprintf(fp_out,"%s\n",s+k);
		 if(nc  == nc1){
	            *n_line = *n_line+1;
	            if(code_out == 1)fprintf(fp_out,"%s\n",s+k);
		    if(*n_line >= nlp_max){
/*	               fprintf(fp_dscr,"OUTPUT n_line=%d pos_s=%ld i+j=%d\n",\
		               *n_line,pos_s,i+j);*/
	               fprintf(fp_dscr,"%ld %d\n",pos_s,i+j);
	               if(code_out == 1)fprintf(fp_out,".NP \n");
		       *n_line = 0;
		       *nb_pages = *nb_pages + 1;
		    }/*if(*n_line >= nlp_max){*/
		 }else{/*if(nc  == nc1){*/
	            *n_line = *n_line+1;
	            if(code_out == 1)fprintf(fp_out,"  %s\n",s+k);
		    nc1=nc;
		    if(*n_line >= nlp_max){
/*	               fprintf(fp_dscr,"OUTPUT n_line=%d pos_s=%ld i+j=%d\n",\
		               *n_line,pos_s,i+j); */
	               fprintf(fp_dscr,"%ld %d\n",pos_s,i+j);
	               if(code_out == 1)fprintf(fp_out,".NP \n");
		       *n_line = 0;
		       *nb_pages = *nb_pages + 1;
		    }/*if(*n_line >= nlp_max){*/
		 }/*if(nc  == nc1){*/
	      i = i+j ;
	      s[i] = BFE;
	   } /* if(s[i+j] == '\0'){*/
	} /*while(l == 0){*/
} /*** end of if s != NULL  ***/
}
/**********************************************************************/
void OUT1_STRING ( long int pos_s, char *s,int *nc0,int nc,int *lb,\
      int *n_line,int nlp_max,int code_out, \
      int *nb_pages,FILE *fp_out, FILE *fp_dscr) 
/*
 *    Writing of the character string s in lines of nc characters long
 *    nc0 characters have been already written
 *    we count also nb the number of blanc lines 
 *    and n_line the number of lines already written
 *    We want pages of nlp_max lines of nc characters long.
 *    fp_out is a file of formated text that will be written if code_out=1
 *    fp_dscr is the description of the original file (we do it)
 *    pos_s is the position of the string s in the original file. This
 *    value is necessary for the writing of the file fp_dscr
 */
{   /****  ==================================    */
char  BFE,c   ;
long nc1,nc2   ;
int i,j,j1,k,l,ic,iup ;
int ncm,ncr,lstop,jback,dn;
int code_blanc;
/*fp = fopen("dicovb","r") ;*/
/*fp = fopen(inFile,"r") ;
fpi = fopen("./ww_net","w+") ;*/
/*********************************************************/
//nc = 70 ;
/*printf("Enter OUT1_STRING code_out=%d lb=%d nline=%d s=%s@@@\n"\
       ,code_out,*lb,*n_line,s);*/
if(nc < 20 )nc=20;
nc1 = nc;
if(*nc0 < 0){ /* We suppose we start a new paragraph */
   nc1=nc+2; // allows to have a line two characters shorter 
   *nc0=0;
}/*if(*nc0 == 0)*/
nc2=nc+nc;
ncm = 15 ; /*** minimum of adding to a string ****/
ncr=20 ; /**  maximum number of reapeated character  **/
//ncm=nc-20;
//if(ncm < 10)ncm=10;
i=0 ;
BFE = 'E';

if (s != NULL  ) {
	l=strlen(s);
	    if(l > 0){
	       code_blanc = 1;
	       i=0;
	       while(i < l && code_blanc == 1){
	          if(s[i] != ' ')code_blanc=0;
		  ++i;
	       }//while(i < nch1 && code_blanc = 1){
	    }//if(nch1 > 0){
/*
 *    Case we have a white line
 */
        j=0;
	if(l <= 0 || code_blanc == 1) {
		 *lb = *lb+1;
//	         printf("OUT1_STRING we have a white line  l<= 0  *lb=%d \n",*lb);
		 if(*lb < 2){
	            *n_line = *n_line+1;
		    if(*n_line >= nlp_max){
	              if(code_out == 1){
		         if(*nc0 > 0 )fprintf(fp_out,"\n"); // terminate preceding line 
		         fprintf(fp_out,".NP \n");
	              }/*if(code_out == 1){*/
	               fprintf(fp_dscr,"%ld %d\n",pos_s,j);
		       *lb=0;
		       *n_line = 0;
		       *nb_pages = *nb_pages+ 1;
		    }else{/*if(*n_line >= nlp_max){*/
		       if(code_out == 1){
		          fprintf(fp_out,"\n");
		          fprintf(fp_out,"\n");
		       }/*if(code_out == 1){*/
	               *n_line = *n_line+1; // terminate+new line = 2
		    }/*if(*n_line >= nlp_max){*/
		 }/*if(*lb < 3){*/
	   *nc0=-1;// We will start a new paragraph 
//	   printf("Quit 1 OUT1_string lb=%d nline=%d \n",*lb,*n_line);
	   return;
	}/* if(l <= 0) {*/
//	printf("\n");
//	printf("enter OUT1_STRING nc0=%d s=%s@@@@ \n",*nc0,s);
	k=0;
	while(s[k] == ' ')++k;
	i= k ;
/*
 *    Problem of a line beginning by the same character reapeated
 *    more than ncr times
 */
        c= s[i];
        while(k < l && s[k]== c )++k;
	if((k-i) >= ncr){/*  use that line as a separation */
	  if(*n_line >= nlp_max){
	    if(code_out == 1){
	       if(*nc0 > 0 ){
	          fprintf(fp_out,"\n"); // terminate preceding line 
	          fprintf(fp_out,".NP \n");
	       }/*if(*nc0 > 0 ){*/
	    }/*if(code_out == 1){*/
	       if(*nc0 > 0 ){
	          *n_line = *n_line+1;
	          fprintf(fp_dscr,"%ld %d\n",pos_s,j);
	       }/*if(*nc0 > 0 ){*/
	    *lb=0;
	    *n_line = 0;
            *nb_pages = *nb_pages+ 1;
	  }else{/*if(*n_line >= nlp_max){*/
	     if(code_out == 1){
	       if(*nc0 > 0 ){
	          fprintf(fp_out,"\n");/*** terminate preceding line  **/
	       }/*if(*nc0 > 0 ){*/
	     }/*if(code_out == 1){*/
	       if(*nc0 > 0 ){
	          *n_line = *n_line+1;
		  *lb=0;
	       }/*if(*nc0 > 0 ){*/
	  }/*if(*n_line >= nlp_max){*/
	  j=k;
	  if(j > i+nc ) j=i+nc;
	  s[j]='\0';
	  if(code_out == 1)fprintf(fp_out,"%s\n",s+i);
	  *n_line = *n_line+1; // terminate+new line = 2
	  *nc0=0;
	  *lb=0;
	  s[j]=c;
	  if(k >= l)return;
	  i=k;
	}/*if((k-i) >= ncr){*/
/*
 *     end of repeated char
 */
	lstop = 0 ;
	while(lstop == 0){ /* main loop through the string starting from i */
	   j = 0 ;
/*	   BFE='|';
	   printf("s[i]=%c  = %d  BFE=%d \n",s[i],s[i],BFE);*/
//	   while (c = s[i+j] && j < n1 && (SPE_ALPHA_NUM(s[i+j]) )++j;
           c= s[i+j];
	   ic=c;
//	   if(ic == -96 || ic == 160 || iscntrl(c)){
	   if(ic == -96 || ic == 160 ){
	      c=' ';
	      s[i+j]=c;
	      ic=c;
	   }/*if(ic == -96 || ic == 160){*/
/*         nc2-nc1 is almost equal to nc */
//	   while ( j < nc2-nc1- (*nc0) && (SPE_ALPHA_NUM(c) || c == ' ' || ispunct(c) )){
//         printf("level -1  l=%d  nc2-nc1-nc0=%ld \n",l,nc2-nc1- (*nc0));
	   dn=0; // introduced to take into account accents coded \'e
	   while ( j < dn+ nc2-nc1- (*nc0) && 
	   (SPE_ALPHA_NUM(c) || SPE_PUNCTU(c) ) && i+j < l ){
	      ++j;
              c= s[i+j];
	      ic=c;
	      if(ic == -96 || ic == 160 ){
	         c=' ';
	         s[i+j]=c;
	         ic=c;
	      }/*if(ic == -96 || ic == 160){*/
	      if(c == '\\')dn=dn+2;
	   }/*while ( j < n1 && (SPE_ALPHA_NUM(c) ||*/
	   if(j == 0 ) ++j;
/******  k is the beginning of s and it has probably been adjusted  */
	   k=i;
	   while(s[k] == ' ')++k;
/******  end adjustment of k    **/
//           printf("write s from i+k=%d to j=%d \n",i+k,j);
	   if(s[i+j] == '\0' ){
/******   We are at the end of the string s      */
/*	    printf(" OUT1_STRING fin ligne i=%d j=%d k = %d\n",i,j,k); 
	      printf("OUT1_STRING s=%s@@@ \n",s+i);*/
	      --j;
	      while((c = s[i+j]) == ' ' ) --j;
	      if(strcspn(s+k," ")){/** if that case we have non space char */
//	         printf("OUTPUT something else than blancs \n");
		 if(nc  == nc1 ){
        /***  we can complete the line and not worry for the 2 blancs   ***/
		    if(j >= (dn+nc2-nc1 - (*nc0))){ 
//		        printf("We complete the line \n");
	               *n_line = *n_line+1;
	               if(code_out == 1) fprintf(fp_out,"%s\n",s+k);
		       if(*n_line >= nlp_max){
	                  if(code_out == 1)fprintf(fp_out,".NP \n");
		          *n_line = 0;
		       }/*if(*n_line >= nlp_max){*/
		       *nc0=0;
		       *lb=0;
                       *nb_pages = *nb_pages+ 1;
		    }else{/*if(j >= *nc2-nc1 - *nc0){ */
/*		       printf(" line not complete j= %d >= dn+nc2-nc1-nc0 = %ld s+k=%s@@ \n",\
		         j, dn+nc2-nc1- (*nc0),s+k);*/
		          if(s[i+j] != '-'){
			     if(code_out == 1)fprintf(fp_out,"%s ",s+k);
		             *nc0 = *nc0+i+j-k+1;
			  }else{//if(s[i+j] != '-'){
			     if(code_out == 1)fprintf(fp_out,"%s",s+k);
		             *nc0 = *nc0+i+j-k;
			  }//if(s[i+j] != '-'){
		       *lb=0;
		    }/*if(j >= *nc2-nc1 - *nc0){ */
		 }else{/*if(nc  == nc1){*/
        /***  we can complete the line but we have 2 blancs   ***/
//	            printf(" We complete the line but we have 2 blancs  \n");
		    if(j >= (dn+nc2-nc1 - (*nc0))){ 
//		       printf("Output line is also complete \n");
	               *n_line = *n_line+1;
		       if(*nc0 == 0){
	                  if(code_out == 1)fprintf(fp_out,"  %s\n",s+k);
		       }else{/*if(*nc0 == 0){*/
	                  if(code_out == 1)fprintf(fp_out,"%s\n",s+k);
		       }/*if(*nc0 == 0){*/
		       nc1=nc;
		       if(*n_line >= nlp_max){
	                  if(code_out == 1) fprintf(fp_out,".NP \n");
		          *n_line = 0;
		       }/*if(*n_line >= nlp_max){*/
		       *nc0 = 0;
		       *lb=0;
		    }else{/*if(j >= *nc2-nc1 - *nc0){ */
//		       printf("Output line is not complete \n");
		       if(*nc0 == 0){
			     if(s[i+j] != '-'){
			        if(code_out == 1)fprintf(fp_out,"  %s ",s+k);
		                *nc0 = *nc0+i+j-k+3;
			     }else{//if(s[i+j] != '-'){
			        if(code_out == 1)fprintf(fp_out,"  %s",s+k);
		                *nc0 = *nc0+i+j-k+2;
			     }//if(s[i+j] != '-'){
			  *lb=0;
		       }else{/*if(*nc0 == 0){*/
	                  if(code_out == 1)fprintf(fp_out,"%s \n",s+k);
			     if(s[i+j] != '-'){
			        if(code_out == 1)fprintf(fp_out,"%s ",s+k);
		                *nc0 = *nc0+i+j-k+1;
			     }else{//if(s[i+j] != '-'){
			        if(code_out == 1)fprintf(fp_out,"%s",s+k);
		                *nc0 = *nc0+i+j-k;
			     }//if(s[i+j] != '-'){
			  *lb=0;
		       }/*if(*nc0 == 0){*/
		       nc1=nc;
		    }/*if(j >= *nc2-nc1 - *nc0){ */
//		    if(*nc0 >= nc)*nc0=0;
		 }/*if(nc  == nc1){*/
		 *lb = 0 ;
//		 printf("We enforce lb=%d \n",*lb);
	      }else{//if(strcspn(s+k,' ')){ We have only space char 
		 *lb = *lb+1;
//	         printf("OUT1_STRING only blancs lb=%d \n",*lb);
		 if(*lb < 3){
	            *n_line = *n_line+1;
		    if(*n_line >= nlp_max){
	                if(code_out == 1) fprintf(fp_out,".NP \n");
		       *lb=0;
		       *n_line = 0;
                       *nb_pages = *nb_pages+ 1;
		    }else{/*if(*n_line >= nlp_max){*/
		       if(code_out == 1)fprintf(fp_out,"\n");
		    }/*if(*n_line >= nlp_max){*/
		 }/*if(*lb < 3){*/
/*****   in that case we begin a new paragraph     ****/
		  *nc0=-1;
		  return;
	      }//if(strcspn(s+k,' ')){
		 lstop=1;
/******   End of : We are at the end of the string s      */
	   }else{ /* if(s[i+j] == '\0'){*/
/******   Start of : We are not at the end of string s      */
//	      if(ic == -96 || ic == 160 || iscntrl(c)){
	      if(ic == -96 || ic == 160 ){ // trial 23-01-2008
	         s[i+j]=' ';
//		 --j;
	      }/*if(iscntrl(s[i+j])){*/
//	      printf("level 0 i=%d k=%d j=%d \n",i,k,j);
	      /*look for first backward blanc*/
	      jback=0;
	      c= s[i+j];
//	      while(j >= 0 && c != ' ' && c != '/' && c != '\\' && jback  <= ncm){
	      while(j >= 0 && c != ' ' && c != '/'  && jback  <= ncm){
	          --j;/*look for first blanc*/
		  c = s[i+j];
		  ++jback;
	      }/*   end of while(j > 0  */
//	      printf("level 1 look back i=%d k=%d j=%d \n",i,k,j);
	      if(j <= 0){/** case we have not been able to add a character */
	      //   We terminate the preceding line 
//		 printf("oblijed terminate preceding line \n");
	         *n_line = *n_line+1;
		 j=0;
	         if(code_out == 1)fprintf(fp_out,"\n");
		 if(*n_line >= nlp_max){
/*	            fprintf(fp_dscr,"OUTPUT n_line=%d pos_s=%ld i+j=%d\n",\
		               *n_line,pos_s,i+j);*/
	            fprintf(fp_dscr,"%ld %d\n",pos_s,i+j);
	            if(code_out == 1)fprintf(fp_out,".NP \n");
		    *n_line = 0;
                    *nb_pages = *nb_pages+ 1;
		 }/*if(*n_line >= nlp_max){*/
		 *nc0=0;
		 *lb=0;
	         continue;
	      }/*if(j == 0){*/
/*	      while(j > nc)--j;
              c=s[i+j];
	      while(c != ' ' && c != '/' && c != 92 && !ispunct(c) && j >= ncm){
	         --j;
                 c=s[i+j];
	      }*//*while(c != ' ' && j >= ncm){*/
/*
 *    j was the first blanc we continue to decrease for all the blancs 
 *    for < " ' <<  --
 */
	      j1= i+j;
	      c = s[j1];
	      ic = c;
/*              while(j > 1 && (c == ' ' || c == '<' || ic == 34 || ic == 39 ||\
	       ic == 171 || ic == 173 || ic == 151 || ic == '(' || c == '-')){*/
              while(j > 1 && (c == ' ' || OPEN_PAR(c) || ic == 34 || ic == 39 ||\
	       ic == 171 || ic == 173 || ic == 151  || c == '-')){
	         --j;
//		 printf("level pre-2 j=%d \n",j);
	         j1= i+j;
	         c = s[j1];
	         ic = c;
	      }
	      ++j;
//	      printf("level 2 i=%d k=%d j=%d \n",i,k,j);
	      j1 = i+j+1;
	      c = s[j1];  
	      ic = c;
//	      printf("OUTPUT after first blanc ligne %d  j1=%d c=%c ic=%d \n",*n_line,j1,c,ic);
/*	      if(s[i+j] == ' ' && ispunct(c) && c != '<' && ic != 38 \
	        && ic != 114 && ic != 171 && c != '(' )j= j1+1;*/
/*
 *   We restart up in some cases for example add the punctuation
 */
              iup=0;
	      if(s[i+j] == ' '){
	         while( j1 < l && ispunct(c)  &&\
		 !(ic == 34 && iup== 0) && !(ic == 39 && iup == 0)\
	         && ic != 171 && ic != 173 && ic != 151 &&\
		  c != '-' && !OPEN_PAR(c)){
		    ++j1;
		    ++iup;
	            c = s[j1];
	            ic = c;
//	            printf("OUTPUT ligne %d  j1=%d c=%c ic=%d \n",*n_line,j1,c,ic);
	         }/*while( ispunct(c) && c != '<' && ic != 38 \*/
		 j=j1-i;
	      }/*if(s[i+j] == ' '){*/
	 /*     printf(" milieu ligne i=%d j=%d \n",i,j) ;*/
	      if(j <= 1 ) j=1;
	      BFE = s[i+j];/* put char in memory   */
	      s[i+j] = '\0';
//	      printf("level 3 i=%d k=%d j=%d \n",i,k,j);
	   /*   printf("%s\n",s+i);*/
//	      fprintf(fp_out,"%s\n",s+k);
		 if(nc  == nc1){
	            *n_line = *n_line+1;
	            if(code_out == 1)fprintf(fp_out,"%s\n",s+k);
		    if(*n_line >= nlp_max){
/*	               fprintf(fp_dscr,"OUTPUT n_line=%d pos_s=%ld i+j=%d\n",\
		               *n_line,pos_s,i+j);*/
	               fprintf(fp_dscr,"%ld %d\n",pos_s,i+j);
	               if(code_out == 1)fprintf(fp_out,".NP \n");
		       *n_line = 0;
		       *nb_pages = *nb_pages + 1;
		    }/*if(*n_line >= nlp_max){*/
		    *nc0=0;
		    *lb=0;
		 }else{/*if(nc  == nc1){*/
	            *n_line = *n_line+1;
	            if(code_out == 1)fprintf(fp_out,"  %s\n",s+k);
		    nc1=nc;
		    if(*n_line >= nlp_max){
/*	               fprintf(fp_dscr,"OUTPUT n_line=%d pos_s=%ld i+j=%d\n",\
		               *n_line,pos_s,i+j); */
	               fprintf(fp_dscr,"%ld %d\n",pos_s,i+j);
	               if(code_out == 1)fprintf(fp_out,".NP \n");
		       *n_line = 0;
		       *nb_pages = *nb_pages + 1;
		    }/*if(*n_line >= nlp_max){*/
		    *nc0=0;
		    *lb=0;
		 }/*if(nc  == nc1){*/
	      i = i+j ;
	      s[i] = BFE;
//	      printf("end loop nc0=%d i=%d l=%d s[i]=%s@@@ \n",*nc0,i,l,s+i);
	      if(i >= l)lstop=1;
	   } /* if(s[i+j] == '\0'){*/
	} /*while(l == 0){*/
} /*** end of if s != NULL  ***/
}
/*################################################################*/
int  OPEN_PAR(char c)
/*
 *    It is true if c = '(' ou '{' ou '[' ou '' ou '<'
 */
  {//==============================================================
  int iout;
     iout=0;
     if(c == '(' || c == '{' || c == '[' || c == '' || c == '<')iout=1;
     return( iout) ;
  }//==============================================================

/*################################################################*/
int EXTR_N_LINT(int n,char *s,long int i_extracted[])
/*
 *   Extract n long int from *s  
 *   Il n'y a que des long int et des blancs en debut de chaine
 *   We return as int the number j   *(s+j) is the character after
 *   the n long int + the blancs
 */
{
int i1,l,j,k;
char s1[101];
   
   l=strlen(s);
   j=0;
   i_extracted[0] = 0;
   while(j < l && *(s+j)== ' ')++j;
   if(j > l )return(j);
      i1=1;
      while(j < l && i1 <= n ){
	 k=0;
	 while(j < l && *(s+j) != ' '){
	    s1[k]=*(s+j);
	    ++k;
	    ++j;
	 }/*while(j < l && s[j] != ' '){*/
	 s1[k]='\0';
	 i_extracted[i1]=atol(s1);
//		printf("i1=%d s1=%s xx1=%15.8f \n",i1,s1,xx1);
         ++i1;
         while(j < l && *(s+j)== ' ')++j;
      }/*for(i1=1;i1 <= n ; ++i1){*/
//      printf("i1 = %d \n",i1);
   i_extracted[0] = i1-1;
   return(j);
}
/*################################################################*/
int EXTR_N_INT(int n,char *s,int i_extracted[])
/*
 *   Extract n int dans *s  
 *   Il n'y a que des int et des blancs en debut de chaine
 *   We return as int the number j   *(s+j) is the character after
 *   the n  int + the blancs
 */
{
int i1,l,j,k;
char s1[101];
   
   l=strlen(s);
   j=0;
   i_extracted[0] = 0;
   while(j < l && *(s+j)== ' ')++j;
   if(j > l )return(j);
      i1=1;
      while(j < l && i1 <= n ){
	 k=0;
	 while(j < l && *(s+j) != ' '){
	    s1[k]=*(s+j);
	    ++k;
	    ++j;
	 }/*while(j < l && s[j] != ' '){*/
	 s1[k]='\0';
	 i_extracted[i1]=atoi(s1);
//		printf("i1=%d s1=%s xx1=%15.8f \n",i1,s1,xx1);
         ++i1;
         while(j < l && *(s+j)== ' ')++j;
      }/*for(i1=1;i1 <= n ; ++i1){*/
//      printf("i1 = %d \n",i1);
   i_extracted[0] = i1-1;
   return(j);

}
/**********************************************************************/
void EXTRACT_ONE_PAGE(int itype,long int li0[], long int li1[], \
         Trf_extrm *extrm,int iappel, FILE *fp , int nb ,\
		long posit[] ,int nb0,\
	long pos_db[],GtkWidget *box1,GtkWidget *lbox2[], \
	GtkWidget *scroll_bzh, GtkWidget *dico_b,   \
	Trf_string *stgs_dico,Trf_klik *klik[])
/*
 *    Extracts and displays one page of text
 *    itype = 1
 *    The original file must be of the kind long line
 *    That is to say one line by paragraph
 *    itype = 2
 *    The original file must be of the kind short lines
 *    That is to say many lines by paragraph
 *    itype = 3
 *    The original file must be of the kind short lines formatted
 *    That is to say many lines by paragraph and each new page
 *    beginning by .NP 
 *    itype = 4
 *    The original file must be of the kind "original formatted"
 *    That is to say many lines by paragraph and each new page
 *    beginning by .NPO or .NHO
 *    We start at position line li0[1] and character li0[2] (The .NP)
 *    We end   at position line li1[1] and character li1[2] (before next .NP)
 */
{ /**  start of EXTRACT_ONE_PAGE   */
int ncharl;
 /*
  * Not understood why but the gtk_rc_parse_string are necessary otherwise
  * the change of file by the command line makes unwanted coloring of 
  * the words when the mouse pointer is on a word and still have a
  * return on the command line 
  */
/*
 */
      char ss_red[]="widget \"*buttonred*\" style \"button_red\"";
      gtk_rc_parse_string(ss_red);
      char ss_redhl[]="widget \"*buttonhlred*\" style \"button_red_hlight\"";
      gtk_rc_parse_string(ss_redhl);
      char ss_green[]="widget \"*buttongreen*\" style \"button_green\"";
      gtk_rc_parse_string(ss_green);
      char ss_blue[]="widget \"*buttonblue*\" style \"button_blue\"";
      gtk_rc_parse_string(ss_blue);
      char ss_bluehl[]="widget \"*buttonhlblue*\" style \"button_blue_hlight\"";
      gtk_rc_parse_string(ss_bluehl);
      char ss_noir[]="widget \"*buttonnoir*\" style \"button_noir\"";
      gtk_rc_parse_string(ss_noir);
      char ss_noirhl[]="widget \"*buttonhlnoir*\" style \"button_noir_hlight\"";
      gtk_rc_parse_string(ss_noirhl);
/*
 *   End of not understood part
 */
     ncharl=(*extrm).nchar_line;
//   int ncharl = 43;
        switch (itype) {
	   case 1:
//	      printf(" call EXTRACT1_ONE_PAGE \n");
 /*             lop= EXTRACT1_ONE_PAGE(li0_extracted, li1_extracted,ncharl\
	           ,fp, fp_out);*/
	      EXTRACT1_ONE_PAGE(li0,li1,ncharl,\
	             extrm,iappel,fp , nb ,posit,nb0,pos_db,\
	             box1,lbox2,scroll_bzh,dico_b, stgs_dico,klik) ;
	      break;
	   case 2:
//	      printf(" call EXTRACT2_ONE_PAGE \n");
   /*           lop= EXTRACT2_ONE_PAGE(li0_extracted, li1_extracted,ncharl\
	           ,fp, fp_out); */
	      EXTRACT2_ONE_PAGE(li0,li1,ncharl,\
	             extrm,iappel,fp , nb ,posit,nb0,pos_db,\
	             box1,lbox2,scroll_bzh,dico_b, stgs_dico,klik) ;
	      break;
	   case 3:// file formated  .NP  .NH
//	      printf(" call EXTRACT3_ONE_PAGE \n");
/*              lop= EXTRACT3_ONE_PAGE(li0_extracted, li1_extracted,ncharl\
	           ,fp, fp_out);*/
	      EXTRACT3_ONE_PAGE(li0,li1,ncharl,\
	             extrm,iappel,fp , nb ,posit,nb0,pos_db,\
	             box1,lbox2,scroll_bzh,dico_b, stgs_dico,klik) ;
	      break;
	   case 4:// file formated original .NPO .NHO
//	      printf(" call EXTRACT4_ONE_PAGE \n");
	      EXTRACT4_ONE_PAGE(li0,li1,\
	             extrm,iappel,fp , nb ,posit,nb0,pos_db,\
	             box1,lbox2,scroll_bzh,dico_b, stgs_dico,klik) ;
	      break;
	   default:
	      printf("EXTRACT_ONE_PAGE itype=%d Not implemented yet \n",itype);
	      EXTRACT4_ONE_PAGE(li0,li1,\
	             extrm,iappel,fp , nb ,posit,nb0,pos_db,\
	             box1,lbox2,scroll_bzh,dico_b, stgs_dico,klik) ;
	      break;
        }// end of switch i0_extracted[1] {
} /**  end of EXTRACT_ONE_PAGE   */
/**********************************************************************/
int EXTRACT1_ONE_PAGE(long int li0[], long int li1[], int ncharl,\
         Trf_extrm *extrm,int iappel, FILE *fp , int nb ,\
		long posit[] ,int nb0,\
	long pos_db[],GtkWidget *box1,GtkWidget *lbox2[], \
	GtkWidget *scroll_bzh, GtkWidget *dico_b,   \
	Trf_string *stgs_dico,Trf_klik *klik[])
/*
 *    Extracts and displays one page of text
 *    The original file must be of the kind long line
 *    That is to say one line by paragraph
 *    We start at position line li0[1] and character li0[2]
 *    We end   at position line li1[1] and character li1[2]
 */
{ /**  start of EXTRACT1_ONE_PAGE   */
long int nbytes,nc;
int page_found,lb,n_line,nc0,ndeb;
long int nb_lu,i,j,l;
long int nch0,nch1;
int ic,iwhite_line,n2charl;
char *ss,c;
W_loop *w_loop1 ;
FILE *fp1, *fph;
int ism,i_dep,j_dep,ib,k,blanc_line,is,dis;
char s1_col[101],s1_word[101],s1_klik[101]  ;
char ss_mem [ISS_MAX+1] [100] ;
   
/*   printf("enter EXTRACT1_ONE_PAGE \n");
   printf("li0[0]=%ld li0[1]=%ld li0[2]=%ld \n",li0[0],li0[1],li0[2]);
   printf("li1[0]=%ld li1[1]=%ld li1[2]=%ld \n",li1[0],li1[1],li1[2]);*/
   w_loop1 =  g_malloc (sizeof( W_loop)); 
   for(i = 0 ; i <= MAX_SHIFT ; ++i){
      (*w_loop1).s_expr[i]= NULL;
   }/*for(i = 0 ; i <= MAX_SHIFT ; ++i){*/
   fp1 = fopen("./idx_gene","r") ;
   fph = fopen("./highlight1","r") ;
   page_found = 0;
   n2charl=ncharl+ncharl;
/*
 */
   is=0;
   strcpy(ss_mem[1],"   ");// not useful ?
   nc0=0; //should be 3 but compted as 0
   ism=ISS_MAX ; /** memory line output  **/
   i_dep=1;
   j_dep=0;
   (*w_loop1).w_shift = 0;
/**  printf("shift=%d \n",w_loop1 -> w_shift);   OK    **/
   ib=-1; /** no of button1 **/
   (*extrm).nb_line=0;
   (*extrm).nb_word=-1;
   k=0;/* it is the number of lines in memory */
   blanc_line = 0 ;/* flag for a blanc_line */
/*
 */
//   ncharl=46;
   nc = li0[1];
   if(fseek(fp,nc,0) != 0){/** This an error of lecture **/
      return(page_found);
   }/**if(fseek(fp,nc,0) == NULL){*/
        nbytes = 100;
	ss =  (char *) malloc((nbytes+5)*sizeof(char));
   if(li1[1] > 0){
      nb_lu = 0;
      i=0;
      lb=0;
      n_line=0;
      ndeb=1;/***  no white lines at beginning of page   ***/
      while(nc <= li1[1] && nb_lu != -2 && i < 100000){
         nb_lu = aln_getline(&ss,&nbytes,fp);
	 DECODE_ACCENTS(ss);
//	 printf("loop while after DECODE_ACCENTS lb=%d\n",lb);
	 l=strlen(ss);
         iwhite_line=0;
	 if(lb >= 2 || ndeb == 1){
/*
 *    Case we have a white line jump if lb >= 2
 */
           iwhite_line=1;
           if(l > 0 ) {
               j=0;
               while(iwhite_line == 1 && j < l){
                  c= ss[j];
                  ic=c;
                  if(c != ' ' && c !='|' && ic != -96 && ic != 160  )iwhite_line = 0;
                  ++j;
               }//while(iwhite_line == 0 & i < l){
            }//if(l > 0 ) {
//	    printf("Test iwhite_line=%d\n",iwhite_line);
	    if(iwhite_line == 1)continue;
	 }//if(lb >= 2 || ndeb == 1){
	 nc0=0;
	 if(nb_lu > 0){
	    dis= is-i_dep+1;
	    if(dis <= 0)dis = dis + ISS_MAX;
	    if(dis >= ISS_MAX && i != 0){
               FLUSH_SS_MEM(&i_dep,&j_dep,is,ss_mem,nb,nb0, \
               posit,pos_db,fp1,fph,box1,lbox2,w_loop1, \
               s1_col,s1_word,s1_klik,scroll_bzh,dico_b, \
               iappel,&ib,stgs_dico,klik,extrm) ;
               k=0;
	       is=1;
               i_dep=1;
               j_dep=0;
	    }else{//if(dis >= ISS_MAX){
              ++is;
	      if(is > ISS_MAX)is=is-ISS_MAX;
	    }//if(dis >= ISS_MAX){
	   ndeb=0;
	   if(i == 0 && li0[2] > 0 ){
              strcpy(ss_mem[is],"   ");
              nc0=0; // should be 3 but compted as 0
	   }else{//if(i == 0 && li0[2] > 0 ){
              strcpy(ss_mem[is],"      ");
              nc0=-1; // should be 6 but compted as -1 : start of paragraph
	   }//if(i == 0 && li0[2] > 0 ){
	 }else{//if(nb_lu > 0){
//	   ndeb=1;  
           continue ;  // A line with nothing on it is ignored
	 }//if(nb_lu > 0){
	 nc = ftell(fp);
//	 printf("loop while nc=%ld nb_lu=%ld\n",nc,nb_lu);
	 if(nb_lu >= 0){
	    nch0=0;
	    if(i == 0)nch0=li0[2];
	    nch1= l;
	/*    if(nch1 == 0){
	       strcpy(ss," ");
	       nch1=1;
	    }//if(nch1 == 0){*/
//	    if(nc > li1[1])nch1=li1[2];
	    if(nc > li1[1]){
	       nch1=li1[2];
	       if(nch1 < 0){
	          nch1 =0;
		  *ss = '\0';
	       }//if(nch1 < 0){
	    }//if(nc > li1[1]){
//	    if(nch1 > 0 || lb < 3){
/*	    printf("EXTRACT1_ONE_PAGE call OUT_STRING_BOOK2 nch0=%ld nch1=%ld \n",nch0,nch1);
	    printf("EXTRACT1_ONE_PAGE write in ss_mem[%d] nb_page_active k=%d\n",is,k);
	    printf("EXTRACT1_ONE_PAGE for FURCH_WORDS i_dep=%d j_dep=%d \n",\
	    i_dep,j_dep);
            DUMP_SS_MEM ( ss_mem,i_dep, is);*/
            OUT_STRING_BOOK2 (nch0, nch1, ss,\
                  &nc0,ncharl,&lb,&n_line,\
                  &is,&k,&i_dep,&j_dep,ss_mem,nb,\
                  nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	          s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	          klik,extrm);
/*	    printf("EXTRACT1_ONE_PAGE after OUT_STRING_BOOK2 lb=%d  \n",lb);
	    printf("EXTRACT1_ONE_PAGE write in ss_mem[%d] nb_page_active k=%d\n",is,k);
	    printf("EXTRACT1_ONE_PAGE after OUT_STRING_BOOK2 i_dep=%d j_dep=%d \n",\
	    i_dep,j_dep);
	    printf("EXTRACT1_ONE_PAGE after OUT_STRING_BOOK2 ndeb=%d lb=%d \n",\
	    ndeb,lb);
            DUMP_SS_MEM ( ss_mem,i_dep, is);*/
	    if( ndeb == 0 && lb == 0 && nch1 == l && l > n2charl){
	    // not beginning of page
	    //and no previous white line and truly end of ss 
	    //and sufficient length of previous line 
/*	    if(is == i_dep)--is;
	    if(is <= 0)is=is+ism;*/
/*	    printf("EXTRACT1_ONE_PAGE separ. parag. call ADD_DISPLAY_SINGLE_LINE \n");
	    printf("EXTRACT1_ONE_PAGE write in ss_mem[%d+1] nb_page_active k=%d\n",is,k);
	    printf("EXTRACT1_ONE_PAGE after OUT_STRING_BOOK2 i_dep=%d j_dep=%d \n",\
	    i_dep,j_dep);
	    printf("EXTRACT1_ONE_PAGE present active ss_mem[%d] \n",is);*/
/*
 *    We systematically add a white line because of end of paragraph
 */
	       strcpy(ss," ");
//	       if(j_dep <= 0)--is;
               ADD_DISPLAY_SINGLE_LINE(ss,&is,&k,&i_dep,&j_dep,&lb,ss_mem,nb,\
               nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	       s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	       klik,extrm);
	       ++n_line;
	       nc0=-1;
/*	    printf("EXTRACT1_ONE_PAGE after ADD_DISPLAY_SINGLE_LINE \n");
	    printf("EXTRACT1_ONE_PAGE new write in ss_mem[%d] nb_page_active k=%d\n",is,k);
	    printf("EXTRACT1_ONE_PAGE after ADD_DISPLAY_SINGLE_LINE i_dep=%d j_dep=%d \n",\
	    i_dep,j_dep);
	    printf("EXTRACT1_ONE_PAGE next active ss_mem[%d] \n",is);
            DUMP_SS_MEM ( ss_mem,i_dep, is);*/
	    }//if( ndeb == 0 ){
//	    }//if(nch1 > 0 || lb < 3){
	 }/*if(nb_lu >= 0){*/
	 ++i;
//	 printf("i=%ld \n",i);
      }/* while(nc <= li1[1]){*/
   }else{/*if(li1[0] > 0){*/
         /***  here we go up to the end of the file ***/
      nb_lu = 0;
      i=0;
      lb=0;
      n_line=0;
      ndeb=1;/***  no white lines at beginning of page   ***/
      while(nb_lu != -2 && i < 100000){
         nb_lu = aln_getline(&ss,&nbytes,fp);
	 DECODE_ACCENTS(ss);
	 l=strlen(ss);
         iwhite_line=0;
	 if(lb >= 2 || ndeb == 1){
/*
 *    Case we have a white line jump if lb >= 2
 */
           iwhite_line=1;
           if(l > 0 ) {
               j=0;
               while(iwhite_line == 1 && j < l){
                  c= ss[j];
                  ic=c;
                  if(c != ' ' && c !='|' && ic != -96 && ic != 160  )iwhite_line = 0;
                  ++j;
               }//while(iwhite_line == 0 & i < l){
            }//if(l > 0 ) {
	    if(iwhite_line == 1)continue;
	 }//if(lb >= 2){
	 nc0=0;
	 if(nb_lu > 0){
	    dis= is-i_dep+1;
	    if(dis <= 0)dis = dis + ISS_MAX;
	    if(dis >= ISS_MAX && i != 0){
               FLUSH_SS_MEM(&i_dep,&j_dep,is,ss_mem,nb,nb0, \
               posit,pos_db,fp1,fph,box1,lbox2,w_loop1, \
               s1_col,s1_word,s1_klik,scroll_bzh,dico_b, \
               iappel,&ib,stgs_dico,klik,extrm) ;
               k=0;
	       is=1;
               i_dep=1;
               j_dep=0;
	    }else{//if(dis >= ISS_MAX){
              ++is;
	      if(is > ISS_MAX)is=is-ISS_MAX;
	    }//if(dis >= ISS_MAX){
	   ndeb=0;
	   if(i == 0 && li0[2] > 0 ){
              strcpy(ss_mem[is],"   ");
              nc0=0;//should be 3 but compted as 0
	   }else{//if(i == 0 && li0[2] > 0 ){
              strcpy(ss_mem[is],"      ");
              nc0=-1;//should be 6 but compted as -1 : start of paragraph
	   }//if(i == 0 && li0[2] > 0 ){
	 }else{//if(nb_lu > 0){
//	   ndeb=1;  
           continue ;  // A line with nothing on it is ignored
	 }//if(nb_lu > 0){
	 if(nb_lu >= 0){
	    nch0=0;
	    if(i == 0) nch0=li0[2];
	    nch1= strlen(ss);
            OUT_STRING_BOOK2 (nch0, nch1, ss,\
                  &nc0,ncharl,&lb,&n_line,\
                  &is,&k,&i_dep,&j_dep,ss_mem,nb,\
                  nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	          s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	          klik,extrm);
	    if( ndeb == 0 && lb == 0 && nch1 == l && l > n2charl){
	    // not beginning of page
	    //and no previous white line and truly end of ss 
	    //and sufficient length of previous line 
	       strcpy(ss," ");
//             COMPLETE_MEMORY_LINE(ss,&is,&k,&i_dep,&j_dep,ss_mem,nb,
               ADD_DISPLAY_SINGLE_LINE(ss,&is,&k,&i_dep,&j_dep,&lb,ss_mem,nb,\
               nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	       s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	       klik,extrm);
	       nc0=-1;
	    }//if( ndeb == 0 ){
	 }/*if(nb_lu >= 0){*/
         ++i;
      }/*while(nb_lu != -2 && i < 100000){*/
   }/*if(li1[0] > 0){*/
              CALL_FLUSH_SS_MEM(&i_dep,&j_dep,is,ss_mem,nb,nb0, \
              posit,pos_db,fp1,fph,box1,lbox2,w_loop1, \
              s1_col,s1_word,s1_klik,scroll_bzh,dico_b, \
              iappel,&ib,stgs_dico,klik,extrm) ;
/*   if(strlen(ss_mem[is])<= 0 && i_dep != is)--is;
   if(is <= 0)is=is+ISS_MAX;
   if(is == i_dep){
      k=1;
      if(strlen(ss_mem[i_dep]) <= 0)k=0;
   }else{//if(*is == i_dep){
      k= is - i_dep + 1;
      if(k <= 0 ) k=k+ISS_MAX;
   }//if(*is == i_dep){*/
/*      k = is-i_dep;  // not good
      if(k <= 0)k=k+ISS_MAX;*/
/*      if(k > 0 ){
         i_fin = i_dep+k-1 ;  
	 if(i_fin > ISS_MAX)i_fin=i_fin-ISS_MAX;
              FLUSH_SS_MEM(&i_dep,&j_dep,i_fin,ss_mem,nb,nb0, \
              posit,pos_db,fp1,fph,box1,lbox2,w_loop1, \
              s1_col,s1_word,s1_klik,scroll_bzh,dico_b, \
              iappel,&ib,stgs_dico,klik,extrm) ;
      }*//*  if(k > 0 ){*/
   if(n_line > 0)page_found = 1;
   free(ss);
   fclose(fp1) ;
   fclose(fph) ;
   g_free(w_loop1);
   return(page_found);
} /**  end of EXTRACT_ONE_PAGE   */
/**********************************************************************/
int EXTRACT2_ONE_PAGE(long int li0[], long int li1[], int ncharl,\
         Trf_extrm *extrm,int iappel, FILE *fp , int nb ,\
		long posit[] ,int nb0,\
	long pos_db[],GtkWidget *box1,GtkWidget *lbox2[], \
	GtkWidget *scroll_bzh, GtkWidget *dico_b,   \
	Trf_string *stgs_dico,Trf_klik *klik[])
/*
 *    Extracts and displays one page of text
 *    The original file must be of the kind short lines
 *    That is to say many lines by paragraph
 *    We start at position line li0[1] and character li0[2]
 *    We end   at position line li1[1] and character li1[2]
 */
{ /**  start of EXTRACT2_ONE_PAGE   */
long int nbytes,nc;
int page_found,lb,n_line,nc0,ndeb,code_blanc;
int is_blanc,lss_mem;
long int nb_lu,i;
long int nch0,nch1;
char *ss,s_work[5];
W_loop *w_loop1 ;
FILE *fp1, *fph;
int ism,i_dep,j_dep,ib,k,blanc_line,is;
char s1_col[101],s1_word[101],s1_klik[101]  ;
char ss_mem [ISS_MAX+1] [100] ;
   
/*   printf("enter EXTRACT2_ONE_PAGE \n");
   printf("li0[0]=%ld li0[1]=%ld li0[2]=%ld \n",li0[0],li0[1],li0[2]);
   printf("li1[0]=%ld li1[1]=%ld li1[2]=%ld \n",li1[0],li1[1],li1[2]);*/
   w_loop1 =  g_malloc (sizeof( W_loop)); 
   for(i = 0 ; i <= MAX_SHIFT ; ++i){
      (*w_loop1).s_expr[i]= NULL;
   }/*for(i = 0 ; i <= MAX_SHIFT ; ++i){*/
   fp1 = fopen("./idx_gene","r") ;
   fph = fopen("./highlight1","r") ;
   page_found = 0;
/*
 */
   is=1;
   strcpy(ss_mem[1],"   ");
   nc0=0;
   ism=ISS_MAX ; /** memory line output  **/
   i_dep=1;
   j_dep=0;
   (*w_loop1).w_shift = 0;
/**  printf("shift=%d \n",w_loop1 -> w_shift);   OK    **/
   ib=-1; /** no of button1 **/
   (*extrm).nb_line=0;
   (*extrm).nb_word=-1;
   k=0;/* it is the number of lines in memory */
   blanc_line = 0 ;/* flag for a blanc_line */
/*
 */
   
//   ncharl=46;
   nc = li0[1];
   if(fseek(fp,nc,0) != 0){/** This an error of lecture **/
      return(page_found);
   }/**if(fseek(fp,nc,0) == NULL){*/
        nbytes = 100;
	ss =  (char *) malloc((nbytes+5)*sizeof(char));
   if(li1[0] > 0){
      nb_lu = 0;
      i=0;
      lb=0;
      n_line=0;
      ndeb=1;/***  no white lines at beginning of page   ***/
      while(nc <= li1[1] && nb_lu != -2 && i < 100000){
         nb_lu = aln_getline(&ss,&nbytes,fp);
	 DECODE_ACCENTS(ss);
	 nc = ftell(fp);
//	 printf("EXTRACT2 loop while nc=%ld nb_lu=%ld\n",nc,nb_lu);
	 if(nb_lu > 0)ndeb=0;
	 if(nb_lu == -2 && lb > 0)continue;
	 if(nb_lu >= 0){
	    nch0=0;
	    if(i == 0)nch0=li0[2];
	    nch1= strlen(ss);
	    if(nc > li1[1]){
	       nch1=li1[2];
	       if(nch1 < 0){
	          nch1 =0;
		  *ss = '\0';
	       }//if(nch1 < 0){
	    }//if(nc > li1[1]){
/*  looking for a blanc line   */
	    if(nch1 > 0){
	       code_blanc = 1;
	       i=0;
	       while(i < nch1 && code_blanc == 1){
	          if(ss[i] != ' ')code_blanc=0;
		  ++i;
	       }//while(i < nch1 && code_blanc = 1){
	       if(code_blanc == 1){
	          nch1 =0;
		  *ss = '\0';
	       }//if(code_blanc == 1){
	    }//if(nch1 > 0){
//	    printf("EXTRACT2 nch1=%ld ss=%s@@@\n",nch1,ss);
	    if(nch1 <= 0 ){
//	    printf("EXTRACT2 call 1 ADD_DISPLAY_SINGLE_LINE nch0=%ld nch1=%ld \n",nch0,nch1);
/*             COMPLETE_MEMORY_LINE(ss,&is,&k,&i_dep,&j_dep,ss_mem,nb,\
               nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	       s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	       klik,extrm);*/
	      if(ndeb == 1)continue;
	      if(lb < 2){
	       strcpy(ss," ");
               ADD_DISPLAY_SINGLE_LINE(ss,&is,&k,&i_dep,&j_dep,&lb,ss_mem,nb,\
               nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	       s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	       klik,extrm);  
/*
 *   for a blanc line ADD_DISPLAY_SINGLE_LINE makes a FLUSH_MEMORY
 *   so is should be is= 1 so no pb for the number of lines
 */
	       if(lb <=2){
	          ++is;
		  if(is > ISS_MAX)is=is-ISS_MAX;
		  ss_mem[is][0]='\0';
	       }//if(lb <=2){
	      }else{//if(nb < 2){
		 if(lb < 2)\
                 COMPLETE_MEMORY_LINE(ss,&is,&k,&i_dep,&j_dep,ss_mem,nb,\
                 nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
                 s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	         klik,extrm);
	      }//if(nb < 2){
/*	    printf("EXTRACT2_ONE_PAGE after ADD_DISPLAY_SINGLE_LINE \n");
	    printf("EXTRACT2_ONE_PAGE new write in ss_mem[%d] nb_page_active k=%d\n",is,k);
	    printf("EXTRACT2_ONE_PAGE after ADD_DISPLAY_SINGLE_LINE i_dep=%d j_dep=%d lb=%d \n",\
	    i_dep,j_dep,lb);
	    printf("EXTRACT2_ONE_PAGE next active ss_mem[%d] \n",is);
            DUMP_SS_MEM ( ss_mem,i_dep, is);*/
	       nc0=-1;
	    }else{//if(nch1 <= 0){
	       if(lb != 0 || (ndeb == 1 && nch0 == 0) ){
	          strcpy(ss_mem[is],"      ");
		  nc0=-1;//should be 6 compted as -1 for start of paragraph
	       }//if(lb != 0 || () ){
               OUT_STRING_BOOK2 (nch0, nch1, ss,\
                  &nc0,ncharl,&lb,&n_line,\
                  &is,&k,&i_dep,&j_dep,ss_mem,nb,\
                  nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	          s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	          klik,extrm);
	    }//if(nch1 <= 0){
	 }else{/*if(nb_lu >= 0){*/
//	    if(ndeb == 0)fprintf(fp_out,"\n"); /* terminate preceeding line */
	    if( ndeb == 0 ){
	       s_work[0]='\0';
               COMPLETE_MEMORY_LINE(s_work,&is,&k,&i_dep,&j_dep,ss_mem,nb,\
               nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	       s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	       klik,extrm);
	       ss_mem[is][0]='\0'; // because COMPLETE_MEMORY_LINE adds
//                      	       blancs on the active line
	    }//if( ndeb == 0 ){
//	    if(lb < 3 && ndeb == 0)fprintf(fp_out,"\n"); /* + white line */
//	    if(lb < 2 && ndeb == 0 ){
	    if(lb == 0 && ndeb == 0 ){
	       //  fprintf(fp_out,"\n"); /* + white line */
	       strcpy(ss," ");
               ADD_DISPLAY_SINGLE_LINE(ss,&is,&k,&i_dep,&j_dep,&lb,ss_mem,nb,\
               nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	       s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	       klik,extrm);
/*
 *   for a blanc line ADD_DISPLAY_SINGLE_LINE makes a FLUSH_MEMORY
 *   so is should be is= 1 so no pb for the number of lines
 */
	       if(lb <=2){
	          ++is;
		  if(is > ISS_MAX)is=is-ISS_MAX;
		  ss_mem[is][0]='\0';
	       }//if(lb <=2){
	    }//if(lb < 3 && ndeb == 0 ){
	    ++lb;
	    nc0=-1;
	 }/*if(nb_lu >= 0){*/
	 ++i;
//	 printf("i=%ld \n",i);
      }/* while(nc <= li1[1]){*/
   }else{/*if(li1[0] > 0){*/
         /***  here we go down to the end of the file ***/
      nb_lu = 0;
      i=0;
      lb=0;
      n_line=0;
//      nc0=0;
      ndeb=1;/***  no white lines at beginning of page   ***/
      while(nb_lu != -2 && i < 100000){
         nb_lu = aln_getline(&ss,&nbytes,fp);
	 DECODE_ACCENTS(ss);
	 if(nb_lu > 0)ndeb=0;
	 if(nb_lu == -2 && lb > 0)continue;
	 if(nb_lu >= 0){
	    nch0=0;
	    if(i == 0)nch0=li0[2];
	    nch1= strlen(ss);
/*  looking for a blanc line   */
	    if(nch1 > 0){
	       code_blanc = 1;
	       i=0;
	       while(i < nch1 && code_blanc == 1){
	          if(ss[i] != ' ')code_blanc=0;
		  ++i;
	       }//while(i < nch1 && code_blanc = 1){
	       if(code_blanc == 1){
	          nch1 =0;
		  *ss = '\0';
	       }//if(code_blanc == 1){
	    }//if(nch1 > 0){
/*	    printf("EXTRACT2 nch1=%ld ss=%s@@@\n",nch1,ss);
//	    if(nch1 < 0) nch0=-1;
	    printf("EXTRACT2 EOF call 2 OUT_STRING_BOOK2 nch0=%ld nch1=%ld \n",nch0,nch1);*/
	    if(nch1 <= 0 ){
	      if(ndeb == 1)continue;
//	       printf("EOF Call 1 COMPLETE_MEMORY_LINE ecrire sur ligne is=%d nb_lignes_actives k=%d\n",is,k);
	       
//	       printf("EOF Call 1 COMPLETE_MEMORY_LINE chercher mots depuis ligneidep=%d colonne j_dep=%d \n",i_dep,j_dep);
	      if(lb < 2){
/*
 *    if lb = 0 and ss_mem[is] is blanc line make it to be null so
 *    ADD_DISPLAY will not add on the next line
 */
	        if(lb == 0){
		   is_blanc=1;
		   if((lss_mem = strlen(ss_mem[is])) > 0){
		     k=0;
		     while(is_blanc == 1 && k < lss_mem){
		        if(ss_mem[is][k] != ' ')is_blanc = 0;
			++k;
		     }//while(iss_blanc = 1 && k < lss_mem){
		   }//if((lss_mem = strlen(ss_mem[is]) > 0){
		   if(is_blanc == 1 )ss_mem[is][0] = '\0';
	        }//if(lb == 0){
	       strcpy(ss," ");
               ADD_DISPLAY_SINGLE_LINE(ss,&is,&k,&i_dep,&j_dep,&lb,ss_mem,nb,\
               nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	       s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	       klik,extrm);  
/*
 *   for a blanc line ADD_DISPLAY_SINGLE_LINE makes a FLUSH_MEMORY
 *   so is should be is= 1 so no pb for the number of lines
 */
	       if(lb <=2){
	          ++is;
		  if(is > ISS_MAX)is=is-ISS_MAX;
		  ss_mem[is][0]='\0';
	       }//if(lb <=2){
	      }//if(nb < 2){
/*	      }else{//if(nb < 2){
//    Warning COMPLETE_MEMORY_LINE adds a few blancs on the next line
		 if(lb < 2)\
                 COMPLETE_MEMORY_LINE(ss,&is,&k,&i_dep,&j_dep,ss_mem,nb,\
                 nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
                 s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	         klik,extrm);
	      }//if(nb < 2){*/
	       nc0=-1;
//	       printf("Sortie EOF 1 COMPLETE_MEMORY_LINE ecrire sur ligne is=%d nb_lignes_actives k=%d\n",is,k);
//	       printf("Sortie EOF 1 COMPLETE_MEMORY_LINE chercher mots depuis ligneidep=%d colonne j_dep=%d \n",i_dep,j_dep);
	       
	    }else{//if(nch1 <= 0){
	       if(lb != 0 || (ndeb == 1 && nch0 == 0) ){
	          strcpy(ss_mem[is],"      ");
		  nc0=-1;//should be 6 but compted as -1 : start of parag.
	       }//if(lb != 0 || () ){
//	       printf("Call 1 OUT_STRING_BOOK2 ecrire sur ligne is=%d nb_lignes_actives k=%d\n",is,k);
	       
//	       printf("Call 1 OUT_STRING_BOOK2 chercher mots depuis ligneidep=%d colonne j_dep=%d \n",i_dep,j_dep);
               OUT_STRING_BOOK2 (nch0, nch1, ss,\
                  &nc0,ncharl,&lb,&n_line,\
                  &is,&k,&i_dep,&j_dep,ss_mem,nb,\
                  nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	          s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	          klik,extrm);
//	       printf("Sortie 1 OUT_STRING_BOOK2 ecrire sur ligne is=%d nb_lignes_actives k=%d\n",is,k);
//	       printf("Sortie 1 OUT_STRING_BOOK2 chercher mots depuis ligneidep=%d colonne j_dep=%d \n",i_dep,j_dep);
	    }//if(nch1 <= 0){
	 }else{/*if(nb_lu >= 0){*/
//	    if(ndeb == 0)fprintf(fp_out,"\n"); /* terminate preceeding line */
//	    if(lb < 3 && ndeb == 0)fprintf(fp_out,"\n"); /* + white line */
//           printf("EXTRACT2_ONE_PAGE nb_lu=%ld negative \n",nb_lu);

/*
 *    if lb = 0 and ss_mem[is] is blanc line make it to be null so
 *    ADD_DISPLAY will not add on the next line
 */
	        if(lb == 0){
		   is_blanc=1;
		   if((lss_mem = strlen(ss_mem[is])) > 0){
		     k=0;
		     while(is_blanc == 1 && k < lss_mem){
		        if(ss_mem[is][k] != ' ')is_blanc = 0;
			++k;
		     }//while(iss_blanc = 1 && k < lss_mem){
		   }//if((lss_mem = strlen(ss_mem[is]) > 0){
		   if(is_blanc == 1 )ss_mem[is][0] = '\0';
	        }//if(lb == 0){
	     if(ndeb == 0 && is_blanc == 0){
//	       printf("call COMPLETE_MEMORY_LINE with a blanc \n");
	       s_work[0]='\0';
               COMPLETE_MEMORY_LINE(s_work,&is,&k,&i_dep,&j_dep,ss_mem,nb,\
               nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	       s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	       klik,extrm);
	       ss_mem[is][0]='\0'; // because COMPLETE_MEMORY_LINE adds
//                      	       blancs on the active line
//	       printf("leaving COMPLETE_MEMORY_LINE with a blanc \n");
//            DUMP_SS_MEM ( ss_mem,i_dep, is);
	     }//if(ndeb == 0){
             if(lb == 0 && ndeb == 0){
 //            printf("EXTRACT2_ONE_PAGE add another white line \n");
	       strcpy(ss," ");
               ADD_DISPLAY_SINGLE_LINE(ss,&is,&k,&i_dep,&j_dep,&lb,ss_mem,nb,\
               nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	       s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	       klik,extrm);
//	       printf("leaving ADD_DISPLAY_SINGLE_LINE \n");
//            DUMP_SS_MEM ( ss_mem,i_dep, is);
/*
 *   for a blanc line ADD_DISPLAY_SINGLE_LINE makes a FLUSH_MEMORY
 *   so is should be is= 1 so no pb for the number of lines
 */
	       if(lb <=2){
	          ++is;
		  if(is > ISS_MAX)is=is-ISS_MAX;
		  ss_mem[is][0]='\0';
	       }//if(lb <=2){
             }//if(lb < 3 && ndeb == 0){
	    ++lb;
	    nc0=-1;
	 }/*if(nb_lu >= 0){*/
         ++i;
      }/*while(nb_lu != -2 && i < 100000){*/
   }/*if(li1[0] > 0){*/
/*
 *   Leaving with a FLUSH
 */
//             printf("EXTRACT2_ONE_PAGE leaving flush \n");
              CALL_FLUSH_SS_MEM(&i_dep,&j_dep,is,ss_mem,nb,nb0, \
              posit,pos_db,fp1,fph,box1,lbox2,w_loop1, \
              s1_col,s1_word,s1_klik,scroll_bzh,dico_b, \
              iappel,&ib,stgs_dico,klik,extrm) ;
   if(n_line > 0)page_found = 1;
   free(ss);
   fclose(fp1) ;
   fclose(fph) ;
   g_free(w_loop1);
   return(page_found);
} /**  end of EXTRACT_ONE_PAGE   */
/**********************************************************************/
int EXTRACT3_ONE_PAGE(long int li0[], long int li1[], int ncharl,\
         Trf_extrm *extrm,int iappel, FILE *fp , int nb ,\
		long posit[] ,int nb0,\
	long pos_db[],GtkWidget *box1,GtkWidget *lbox2[], \
	GtkWidget *scroll_bzh, GtkWidget *dico_b,   \
	Trf_string *stgs_dico,Trf_klik *klik[])
/*
 *    Extracts and displays one page of text
 *    The original file must be of the kind short lines
 *    That is to say many lines by paragraph
 *    We start at position line li0[1] and character li0[2]
 *    We end   at position line li1[1] and character li1[2]
 */
{ /**  start of EXTRACT3_ONE_PAGE   */
long int nbytes,nc;
int page_found,lb,n_line,nc0,ndeb,code_blanc;
int is_blanc,lss_mem;
long int nb_lu,i,nch75;
long int nch0,nch1;
char *ss,s_work[5];
W_loop *w_loop1 ;
FILE *fp1, *fph;
int ism,i_dep,j_dep,ib,k,blanc_line,is,inp,j;
char s1_col[101],s1_word[101],s1_klik[101]  ;
char ss_mem [ISS_MAX+1] [100] ;
   
/*   printf("enter EXTRACT3_ONE_PAGE \n");
   printf("li0[0]=%ld li0[1]=%ld li0[2]=%ld \n",li0[0],li0[1],li0[2]);
   printf("li1[0]=%ld li1[1]=%ld li1[2]=%ld \n",li1[0],li1[1],li1[2]);*/
   w_loop1 =  g_malloc (sizeof( W_loop)); 
   for(i = 0 ; i <= MAX_SHIFT ; ++i){
      (*w_loop1).s_expr[i]= NULL;
   }/*for(i = 0 ; i <= MAX_SHIFT ; ++i){*/
   fp1 = fopen("./idx_gene","r") ;
   fph = fopen("./highlight1","r") ;
   page_found = 0;
   nch75=0.75*ncharl;
/*
 */
   is=1;
   strcpy(ss_mem[1],"   ");
   nc0=3;
   ism=ISS_MAX ; /** memory line output  **/
   i_dep=1;
   j_dep=0;
   (*w_loop1).w_shift = 0;
/**  printf("shift=%d \n",w_loop1 -> w_shift);   OK    **/
   ib=-1; /** no of button1 **/
   (*extrm).nb_line=0;
   (*extrm).nb_word=-1;
   k=0;/* it is the number of lines in memory */
   blanc_line = 0 ;/* flag for a blanc_line */
/*
 */
   
//   ncharl=46;
   nc = li0[1];
   if(fseek(fp,nc,0) != 0){/** This an error of lecture **/
      return(page_found);
   }/**if(fseek(fp,nc,0) == NULL){*/
        nbytes = 100;
	ss =  (char *) malloc((nbytes+5)*sizeof(char));
   if(li1[0] > 0){
      nb_lu = 0;
      i=0;
      lb=0;
      n_line=0;
      ndeb=1;/***  no white lines at beginning of page   ***/
      while(nc <= li1[1] && nb_lu != -2 && i < 100000){
         nb_lu = aln_getline(&ss,&nbytes,fp);
	 DECODE_ACCENTS(ss);
	 nc = ftell(fp);
//	 printf("EXTRACT3 loop while nc=%ld nb_lu=%ld\n",nc,nb_lu);
	 if(nb_lu > 0)ndeb=0;
	 if(nb_lu == -2 && lb > 0)continue;
/* 
 *     Detection of .NP   ou .NH
 */
         inp=0;
	 if(nb_lu > 0){
	    j=0;
	    while(j <= nb_lu && *(ss+j)== ' ')++j;
	    if(j+2 <= nb_lu){
	       if(*(ss+j) == '.' && *(ss+j+1) == 'N' &&\
	           ( *(ss+j+2)=='P' || *(ss+j+2) == 'H' ) )inp=1;
	    }//if(j+2 <= nb_lu){
	 }//if(nb_lu > 0){
//	 printf("EXTRACT3_ONE_PAGE level 1 inp=%d\n",inp);
	 if(nb_lu >= 0 && inp == 0){
	    nch0=0;
	    if(i == 0)nch0=li0[2];
	    nch1= strlen(ss);
	    if(nc > li1[1]){
	       nch1=li1[2];
	       if(nch1 < 0){
	          nch1 =0;
		  *ss = '\0';
	       }//if(nch1 < 0){
	    }//if(nc > li1[1]){
/*  looking for a blanc line   */
	    if(nch1 > 0){
	       code_blanc = 1;
	       i=0;
	       while(i < nch1 && code_blanc == 1){
	          if(ss[i] != ' ')code_blanc=0;
		  ++i;
	       }//while(i < nch1 && code_blanc = 1){
	       if(code_blanc == 1){
	          nch1 =0;
		  *ss = '\0';
	       }//if(code_blanc == 1){
	    }//if(nch1 > 0){
//	    printf("EXTRACT3 nch1=%ld ss=%s@@@\n",nch1,ss);
	    if(nch1 <= 0 ){
//	    printf("EXTRACT3 call 1 ADD_DISPLAY_SINGLE_LINE nch0=%ld nch1=%ld \n",nch0,nch1);
/*             COMPLETE_MEMORY_LINE(ss,&is,&k,&i_dep,&j_dep,ss_mem,nb,\
               nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	       s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	       klik,extrm);*/
	      if(ndeb == 1)continue;
	      if(lb < 2){
/*
 *    if lb = 0 and ss_mem[is] is blanc line make it to be null so
 *    ADD_DISPLAY will not add on the next line
 */
	        if(lb == 0){
		   is_blanc=1;
		   if((lss_mem = strlen(ss_mem[is])) > 0){
		     k=0;
		     while(is_blanc == 1 && k < lss_mem){
		        if(ss_mem[is][k] != ' ')is_blanc = 0;
			++k;
		     }//while(iss_blanc = 1 && k < lss_mem){
		   }//if((lss_mem = strlen(ss_mem[is]) > 0){
		   if(is_blanc == 1 )ss_mem[is][0] = '\0';
	        }//if(lb == 0){
	       strcpy(ss," ");
               ADD_DISPLAY_SINGLE_LINE(ss,&is,&k,&i_dep,&j_dep,&lb,ss_mem,nb,\
               nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	       s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	       klik,extrm);  
/*
 *   for a blanc line ADD_DISPLAY_SINGLE_LINE makes a FLUSH_MEMORY
 *   so is should be is= 1 so no pb for the number of lines
 */
	       if(lb <=2){
	          ++is;
		  if(is > ISS_MAX)is=is-ISS_MAX;
		  ss_mem[is][0]='\0';
	       }//if(lb <=2){
//	      }else{//if(nb < 2){
/*		 if(lb < 2)\
                 COMPLETE_MEMORY_LINE(ss,&is,&k,&i_dep,&j_dep,ss_mem,nb,\
                 nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
                 s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	         klik,extrm);*/
	      }//if(nb < 2){
/*	    printf("EXTRACT3_ONE_PAGE after ADD_DISPLAY_SINGLE_LINE \n");
//	    printf("EXTRACT3_ONE_PAGE new write in ss_mem[%d] nb_page_active k=%d\n",is,k);
	    printf("EXTRACT3_ONE_PAGE after ADD_DISPLAY_SINGLE_LINE i_dep=%d j_dep=%d lb=%d \n",\
	    i_dep,j_dep,lb);
	    printf("EXTRACT3_ONE_PAGE next active ss_mem[%d] \n",is);
            DUMP_SS_MEM ( ss_mem,i_dep, is);*/
	       nc0=-1;
	    }else{//if(nch1 <= 0){
	       if(lb != 0 || (ndeb == 1 && nch0 == 0) ){
	          strcpy(ss_mem[is],"      ");
		  nc0=6;
	       }//if(lb != 0 || () ){
/*
 *   small line following a blanc line is supposed to be there 
 *   on purpose
 */
               if(lb != 0 && nch1-nch0+1 < nch75 ){
                 COMPLETE_MEMORY_LINE(ss,&is,&k,&i_dep,&j_dep,ss_mem,nb,\
                 nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
                 s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	         klik,extrm);
		 lb=0;
              /*   ADD_DISPLAY_SINGLE_LINE(ss,&is,&k,&i_dep,&j_dep,&lb,\
		 ss_mem,nb,\
                 nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	         s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	         klik,extrm);  */
               }else{//if(lb != 0 && nch1-nch0+1 < nch75 ){
                  OUT_STRING_BOOK2 (nch0, nch1, ss,\
                  &nc0,ncharl,&lb,&n_line,\
                  &is,&k,&i_dep,&j_dep,ss_mem,nb,\
                  nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	          s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	          klik,extrm);
               }//if(lb != 0 && nch1-nch0+1 < nch75 ){
	    }//if(nch1 <= 0){
	 }else{/*if(nb_lu >= 0 && inp= 0 ){*/
//	    if(ndeb == 0)fprintf(fp_out,"\n"); /* terminate preceeding line */
/*
 *    if lb = 0 and ss_mem[is] is blanc line make it to be null so
 *    ADD_DISPLAY will not add on the next line
 */
	        if(lb == 0){
		   is_blanc=1;
		   if((lss_mem = strlen(ss_mem[is])) > 0){
		     k=0;
		     while(is_blanc == 1 && k < lss_mem){
		        if(ss_mem[is][k] != ' ')is_blanc = 0;
			++k;
		     }//while(iss_blanc = 1 && k < lss_mem){
		   }//if((lss_mem = strlen(ss_mem[is]) > 0){
		   if(is_blanc == 1 )ss_mem[is][0] = '\0';
	        }//if(lb == 0){
	    if( ndeb == 0 && is_blanc == 0){
	       s_work[0]='\0';
               COMPLETE_MEMORY_LINE(s_work,&is,&k,&i_dep,&j_dep,ss_mem,nb,\
               nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	       s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	       klik,extrm);
	       ss_mem[is][0]='\0'; // because COMPLETE_MEMORY_LINE adds
//                      	       blancs on the active line
	    }//if( ndeb == 0 ){
//	    if(lb < 3 && ndeb == 0)fprintf(fp_out,"\n"); /* + white line */
	    if(lb < 2 && ndeb == 0 ){
	       //  fprintf(fp_out,"\n"); /* + white line */
	       strcpy(ss," ");
               ADD_DISPLAY_SINGLE_LINE(ss,&is,&k,&i_dep,&j_dep,&lb,ss_mem,nb,\
               nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	       s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	       klik,extrm);
/*
 *   for a blanc line ADD_DISPLAY_SINGLE_LINE makes a FLUSH_MEMORY
 *   so is should be is= 1 so no pb for the number of lines
 */
	       if(lb <=2){
	          ++is;
		  if(is > ISS_MAX)is=is-ISS_MAX;
		  ss_mem[is][0]='\0';
	       }//if(lb <=2){
	    }//if(lb < 3 && ndeb == 0 ){
	    ++lb;
	    nc0=-1;
	 }/*if(nb_lu >= 0){*/
	 ++i;
//	 printf("i=%ld \n",i);
      }/* while(nc <= li1[1]){*/
   }else{/*if(li1[0] > 0){*/
         /***  here we go down to the end of the file ***/
      nb_lu = 0;
      i=0;
      lb=0;
      n_line=0;
//      nc0=0;
      ndeb=1;/***  no white lines at beginning of page   ***/
      while(nb_lu != -2 && i < 100000){
         nb_lu = aln_getline(&ss,&nbytes,fp);
	 DECODE_ACCENTS(ss);
	 if(nb_lu > 0)ndeb=0;
	 if(nb_lu == -2 && lb > 0)continue;
	 if(nb_lu >= 0){
	    nch0=0;
	    if(i == 0)nch0=li0[2];
	    nch1= strlen(ss);
/*  looking for a blanc line   */
	    if(nch1 > 0){
	       code_blanc = 1;
	       i=0;
	       while(i < nch1 && code_blanc == 1){
	          if(ss[i] != ' ')code_blanc=0;
		  ++i;
	       }//while(i < nch1 && code_blanc = 1){
	       if(code_blanc == 1){
	          nch1 =0;
		  *ss = '\0';
	       }//if(code_blanc == 1){
	    }//if(nch1 > 0){
/*	    printf("EXTRACT3 nch1=%ld ss=%s@@@\n",nch1,ss);

//	    if(nch1 < 0) nch0=-1;
	    printf("EXTRACT3 EOF call 2 OUT_STRING_BOOK2 nch0=%ld nch1=%ld \n",nch0,nch1);*/
	    if(nch1 <= 0 ){
	      if(ndeb == 1)continue;
/*	       printf("EOF Call 1 COMPLETE_MEMORY_LINE ecrire sur ligne is=%d nb_lignes_actives k=%d\n",is,k);
	       
	       printf("EOF Call 1 COMPLETE_MEMORY_LINE chercher mots depuis ligneidep=%d colonne j_dep=%d \n",i_dep,j_dep);*/
	      if(lb < 2){
/*
 *    if lb = 0 and ss_mem[is] is blanc line make it to be null so
 *    ADD_DISPLAY will not add on the next line
 */
	        if(lb == 0){
		   is_blanc=1;
		   if((lss_mem = strlen(ss_mem[is])) > 0){
		     k=0;
		     while(is_blanc == 1 && k < lss_mem){
		        if(ss_mem[is][k] != ' ')is_blanc = 0;
			++k;
		     }//while(iss_blanc = 1 && k < lss_mem){
		   }//if((lss_mem = strlen(ss_mem[is]) > 0){
		   if(is_blanc == 1 )ss_mem[is][0] = '\0';
	        }//if(lb == 0){
	       strcpy(ss," ");
               ADD_DISPLAY_SINGLE_LINE(ss,&is,&k,&i_dep,&j_dep,&lb,ss_mem,nb,\
               nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	       s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	       klik,extrm);  
/*
 *   for a blanc line ADD_DISPLAY_SINGLE_LINE makes a FLUSH_MEMORY
 *   so is should be is= 1 so no pb for the number of lines
 */
	       if(lb <=2){
	          ++is;
		  if(is > ISS_MAX)is=is-ISS_MAX;
		  ss_mem[is][0]='\0';
	       }//if(lb <=2){
	      }//if(nb < 2){
/*	      }else{//if(nb < 2){
//    Warning COMPLETE_MEMORY_LINE adds a few blancs on the next line
		 if(lb < 2)\
                 COMPLETE_MEMORY_LINE(ss,&is,&k,&i_dep,&j_dep,ss_mem,nb,\
                 nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
                 s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	         klik,extrm);
	      }//if(nb < 2){*/
	       nc0=-1;
/*	       printf("Sortie EOF 1 COMPLETE_MEMORY_LINE ecrire sur ligne is=%d nb_lignes_actives k=%d\n",is,k);
	       printf("Sortie EOF 1 COMPLETE_MEMORY_LINE chercher mots depuis ligneidep=%d colonne j_dep=%d \n",i_dep,j_dep);*/
	       
	    }else{//if(nch1 <= 0){
	       if(lb != 0 || (ndeb == 1 && nch0 == 0) ){
	          strcpy(ss_mem[is],"      ");
		  nc0=6;
	       }//if(lb != 0 || () ){
/*	       printf("Call 1 OUT_STRING_BOOK2 ecrire sur ligne is=%d nb_lignes_actives k=%d\n",is,k);
	       
	       printf("Call 1 OUT_STRING_BOOK2 chercher mots depuis ligneidep=%d colonne j_dep=%d \n",i_dep,j_dep);*/
               OUT_STRING_BOOK2 (nch0, nch1, ss,\
                  &nc0,ncharl,&lb,&n_line,\
                  &is,&k,&i_dep,&j_dep,ss_mem,nb,\
                  nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	          s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	          klik,extrm);
/*	       printf("Sortie 1 OUT_STRING_BOOK2 ecrire sur ligne is=%d nb_lignes_actives k=%d\n",is,k);
	       printf("Sortie 1 OUT_STRING_BOOK2 chercher mots depuis ligneidep=%d colonne j_dep=%d \n",i_dep,j_dep);*/
	    }//if(nch1 <= 0){
	 }else{/*if(nb_lu >= 0){*/
//	    if(ndeb == 0)fprintf(fp_out,"\n"); /* terminate preceeding line */
//	    if(lb < 3 && ndeb == 0)fprintf(fp_out,"\n"); /* + white line */
//             printf("EXTRACT3_ONE_PAGE nb_lu=%ld negative \n",nb_lu);
/*
 *    if lb = 0 and ss_mem[is] is blanc line make it to be null so
 *    ADD_DISPLAY will not add on the next line
 */
	        if(lb == 0){
		   is_blanc=1;
		   if((lss_mem = strlen(ss_mem[is])) > 0){
		     k=0;
		     while(is_blanc == 1 && k < lss_mem){
		        if(ss_mem[is][k] != ' ')is_blanc = 0;
			++k;
		     }//while(iss_blanc = 1 && k < lss_mem){
		   }//if((lss_mem = strlen(ss_mem[is]) > 0){
		   if(is_blanc == 1 )ss_mem[is][0] = '\0';
	        }//if(lb == 0){
	     if(ndeb == 0 && is_blanc == 0){
//	       strcpy(ss," ");
//	       printf("call COMPLETE_MEMORY_LINE with a blanc \n");
	       s_work[0]='\0';
               COMPLETE_MEMORY_LINE(s_work,&is,&k,&i_dep,&j_dep,ss_mem,nb,\
               nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	       s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	       klik,extrm);
	       ss_mem[is][0]='\0'; // because COMPLETE_MEMORY_LINE adds
//                      	       blancs on the active line
//	       printf("leaving COMPLETE_MEMORY_LINE with a blanc \n");
//            DUMP_SS_MEM ( ss_mem,i_dep, is);
	     }//if(ndeb == 0){
//             if(lb < 2 && ndeb == 0){
             if(lb == 0 && ndeb == 0){
//             printf("EXTRACT3_ONE_PAGE add another white line \n");
	       strcpy(ss," ");
               ADD_DISPLAY_SINGLE_LINE(ss,&is,&k,&i_dep,&j_dep,&lb,ss_mem,nb,\
               nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	       s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	       klik,extrm);
//	       printf("leaving ADD_DISPLAY_SINGLE_LINE \n");
//            DUMP_SS_MEM ( ss_mem,i_dep, is);
/*
 *   for a blanc line ADD_DISPLAY_SINGLE_LINE makes a FLUSH_MEMORY
 *   so is should be is= 1 so no pb for the number of lines
 */
	       if(lb <=2){
	          ++is;
		  if(is > ISS_MAX)is=is-ISS_MAX;
		  ss_mem[is][0]='\0';
	       }//if(lb <=2){
             }//if(lb < 3 && ndeb == 0){
	    ++lb;
	    nc0=-1;
	 }/*if(nb_lu >= 0){*/
         ++i;
      }/*while(nb_lu != -2 && i < 100000){*/
   }/*if(li1[0] > 0){*/
/*
 *   Leaving with a FLUSH
 */
//             printf("EXTRACT3_ONE_PAGE leaving flush \n");
              CALL_FLUSH_SS_MEM(&i_dep,&j_dep,is,ss_mem,nb,nb0, \
              posit,pos_db,fp1,fph,box1,lbox2,w_loop1, \
              s1_col,s1_word,s1_klik,scroll_bzh,dico_b, \
              iappel,&ib,stgs_dico,klik,extrm) ;
   if(n_line > 0)page_found = 1;
   free(ss);
   fclose(fp1) ;
   fclose(fph) ;
   g_free(w_loop1);
   return(page_found);
} /**  end of EXTRACT_ONE_PAGE   */
/**********************************************************************/
int EXTRACT4_ONE_PAGE(long int li0[], long int li1[], \
         Trf_extrm *extrm,int iappel, FILE *fp , int nb ,\
		long posit[] ,int nb0,\
	long pos_db[],GtkWidget *box1,GtkWidget *lbox2[], \
	GtkWidget *scroll_bzh, GtkWidget *dico_b,   \
	Trf_string *stgs_dico,Trf_klik *klik[])
/*
 *    Extracts and displays one page of text
 *    The original file must be of the kind "original formatted"
 *    That is to say many lines by paragraph and each new page
 *    beginning by .NPO or .NHO
 *    We start at position line li0[1] and character li0[2] (The .NPO)
 *    We end   at position line li1[1] and character li1[2] 
 *                                                  (before next .NPO)
 *    .NPO   New Page Original
 *    .NHO   New Header-page Original
 *    .NTO   New Text Original
 *    .NFO   New Footer Original
 */
{ /**  start of EXTRACT_ONE_PAGE   */
long int nbytes,nc;
int page_found,lb,n_line,ndeb;
long int nb_lu,i,j,l,icode;
long int nch0,nch1,inp;
char *ss,*spos,*spos1,c;
W_loop *w_loop1 ;
FILE *fp1, *fph;
int ism,i_dep,j_dep,ib,k,blanc_line,is,lss;
char s1_col[101],s1_word[101],s1_klik[101]  ;
char ss_mem [ISS_MAX+1] [100] ;
   
/*   printf("enter EXTRACT4_ONE_PAGE \n");
   printf("li0[0]=%ld li0[1]=%ld li0[2]=%ld \n",li0[0],li0[1],li0[2]);
   printf("li1[0]=%ld li1[1]=%ld li1[2]=%ld \n",li1[0],li1[1],li1[2]);*/
/*
 */
   w_loop1 =  g_malloc (sizeof( W_loop)); 
   for(i = 0 ; i <= MAX_SHIFT ; ++i){
      (*w_loop1).s_expr[i]= NULL;
   }/*for(i = 0 ; i <= MAX_SHIFT ; ++i){*/
   fp1 = fopen("./idx_gene","r") ;
   fph = fopen("./highlight1","r") ;
/*
 */
   page_found = 0;
//   ncharl=46;
   nc = li0[1];
   if(fseek(fp,nc,0) != 0){/** This an error of lecture **/
      return(page_found);
   }/**if(fseek(fp,nc,0) == NULL){*/
/*
 */
   is=1;
   strcpy(ss_mem[is],"   ");
   ism=ISS_MAX ; /** memory line output  **/
   i_dep=1;
   j_dep=0;
   (*w_loop1).w_shift = 0;
/**  printf("shift=%d \n",w_loop1 -> w_shift);   OK    **/
   ib=-1; /** no of button1 **/
   (*extrm).nb_line=0;
   (*extrm).nb_word=-1;
   k=0;/* it is the number of lines in memory */
   blanc_line = 0 ;/* flag for a blanc_line */
/*
 */
        nbytes = 100;
	ss =  (char *) malloc((nbytes+5)*sizeof(char));
   if(li1[0] > 0){  // if true, we don't go to the end of the file
      nb_lu = 0;
      i=0;
      lb=0;
      n_line=0;
//      nc0=0;
      ndeb=0;/***  no white lines at beginning of page   ***/
      while(nc <= li1[1] && nb_lu != -2 && i < 100000){
         nb_lu = aln_getline(&ss,&nbytes,fp);
	 DECODE_ACCENTS(ss);

	 nc = ftell(fp);
/*	 printf("EXTRACT4 loop while nc=%ld nb_lu=%ld\n",nc,nb_lu);
	 printf("ss=%s\n",ss);*/
//	 if(nb_lu > 0)ndeb=0;
/* 
 *     Detection of .NPO ou .NHO
 */
         inp=0;
	 if(nb_lu > 0){
	    j=0;
	    while(j <= nb_lu && *(ss+j)== ' ')++j;
	    if(j+3 <= nb_lu){
	       if(*(ss+j) == '.' && *(ss+j+1) == 'N' &&\
	            ( *(ss+j+2)=='P' || *(ss+j+2) == 'H' ) \
		             && *(ss+j+3)== 'O'){
		  inp=1;
		  ++ndeb;
	       }//if(*(ss+j) == '.' && *(ss+j+1) == 'N' &&
	    }//if(j+2 <= nb_lu){
	 }//if(nb_lu > 0){
	 if(nb_lu >= 0 && inp == 0){
	    nch0=0;
	    if(i == 0)nch0=li0[2];
	    nch1= strlen(ss);
	    if(nc > li1[1])nch1=li1[2];
/*
 * Detection of .NTO and .NFO
 */
	    spos = strstr(ss,".NTO");
	    spos1 = strstr(ss,".NFO");
	    if(spos == NULL && spos1 == NULL){
//	       fprintf(fp_out,"%s\n",ss);
               COMPLETE_MEMORY_LINE(ss,&is,&k,&i_dep,&j_dep,ss_mem,nb,\
               nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	       s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	       klik,extrm);
//	       nc0=-1;
	    }else{//if(spos == NULL){
	       l=-1;
	       if(spos != NULL){
	          l= spos - ss;
	       }else{//if(spos != NULL){
	          l= spos1 - ss;
	       }//if(spos != NULL){
	       icode = 0;
	       j=0;
	       if (l > 0){// detection of blancs which are accepted
	          while(icode == 0 && j < l){
		     if(ss[j] != ' ')icode = 1;
		     ++j;
	          }//while(icode = 0 && j < l){
	       }//if (l > 0){
	       if(icode == 0){// print a separation
	          c = '_';
		  for(j= 0 ; j < 30 ; ++j)ss[j] = c;
		  ss[j]='\0';
/*	          fprintf(fp_out,"%s\n",ss);
	          fprintf(fp_out,"\n");*/
                  COMPLETE_MEMORY_LINE(ss,&is,&k,&i_dep,&j_dep,ss_mem,nb,\
		  nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
		  s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
		  klik,extrm);
		  strcpy(ss," ");
                  ADD_DISPLAY_SINGLE_LINE(ss,&is,&k,&i_dep,&j_dep,&lb,ss_mem,nb,\
		  nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
		  s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
		  klik,extrm);
		  strcpy(ss_mem[is],"   ");
//		  nc0=3;
	       }else{//if(icode == 0){
//	          fprintf(fp_out,"%s\n",ss); // not .NTO
                  COMPLETE_MEMORY_LINE(ss,&is,&k,&i_dep,&j_dep,ss_mem,nb,\
		  nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
		  s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
		  klik,extrm);
//		  nc0=-1;
	       }//if(icode == 0){
	    }//if(spos == NULL){
/*
 *   End detection of .NTO and otherwise writing of line
 */
	    ++n_line;
//	    nc0=-1;
	 }else{//if(nb_lu >= 0 && inp == 0){
//	    if(ndeb == 0)fprintf(fp_out,"\n"); /* terminate preceeding line */
/*	    if(lb < 3 && ndeb == 0 && inp == 0)\
	                           fprintf(fp_out,"\n");*/ /* + white line */
/*	    printf("EXTRACT4_ONE_PAGE  terminate page before COMPLETE_M_LINE\n");
            DUMP_SS_MEM ( ss_mem,i_dep, is);*/
/*  	    if(ndeb == 0){// terminate preceeding line 
		  strcpy(ss," ");
                  COMPLETE_MEMORY_LINE(ss,&is,&k,&i_dep,&j_dep,ss_mem,nb,\
		  nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
		  s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
		  klik,extrm);
		  ss_mem[is][0]='\0';
  	    }*///if(ndeb == 0){
//	    if(lb < 3 && ndeb == 0 && inp == 0){
	    ss_mem[is][0]='\0'; // because we always have blancs inserted
	                        // at beginning of ss_mem and 
	// ADD_DISPLAY_SINGLE_LINE then close it and add still another line 
/*	    printf("EXTRACT4_ONE_PAGE  terminate page before ADD_DISPLAY_S_LINE\n");
            DUMP_SS_MEM ( ss_mem,i_dep, is);*/
	    if(lb < 2 ){
		  strcpy(ss," ");
                  ADD_DISPLAY_SINGLE_LINE(ss,&is,&k,&i_dep,&j_dep,&lb,ss_mem,nb,\
		  nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
		  s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
		  klik,extrm);
	    }//if(lb < 3 && ndeb == 0 && inp == 0){
/*	    printf("EXTRACT4_ONE_PAGE  terminate page after ADD_DISPLAY_S_LINE\n");
            DUMP_SS_MEM ( ss_mem,i_dep, is);*/
//	    ++lb;
//	    nc0=-1;
	    nb_lu=-2;
	 }/*if(nb_lu >= 0){*/
	 ++i;
//	 printf("i=%ld \n",i);
      }/* while(nc <= li1[1]){*/
	    ss_mem[is][0]='\0'; // because we always have blancs inserted
   }else{/*if(li1[0] > 0){*/
         /***  here we go down to the end of the file ***/
//      printf("EXTRACT4_ONE_PAGE  go down to end of file \n");
      nb_lu = 0;
      i=0;
      lb=0;
      n_line=0;
//      nc0=0;
      ndeb=1;/*** Not NPO at end of file  ***/
      while(nb_lu != -2 && i < 100000){
         nb_lu = aln_getline(&ss,&nbytes,fp);
	 DECODE_ACCENTS(ss);
//	 printf("EXTRACT4 down end file loop while nc=%ld nb_lu=%ld\n",nc,nb_lu);
//	 if(nb_lu > 0)ndeb=0;
/* 
 *     Detection of .NPO ou .NHO
 */
         inp=0;
	 lss=strlen(ss);
	 if(lss <= 0){
	    *ss= ' ';
	    *(ss+1) = '\0';
	    lss=1;
	 }//if(lss <= 0){
	 if(nb_lu > 0){
	    j=0;
	    while(j <= nb_lu && *(ss+j)== ' ')++j;
	    if(j+3 <= nb_lu){
	       if(*(ss+j) == '.' && *(ss+j+1) == 'N' &&\
	            ( *(ss+j+2)=='P' || *(ss+j+2) == 'H' ) \
		             && *(ss+j+3)== 'O'){
		  inp=1;
		  ++ndeb;
	       }//if(*(ss+j) == '.' && *(ss+j+1) == 'N' &&
	    }//if(j+2 <= nb_lu){
	 }//if(nb_lu > 0){
//	 printf("ndeb=%d ss=%s\n",ndeb, ss);
	 if(nb_lu >= 0 && inp == 0){
//	    printf(" .NPO .NHO  not detected  \n");
	    nch0=0;
	    if(i == 0)nch0=li0[2];
	    nch1= strlen(ss);
/*
 * Detection of .NTO and .NFO
 */
	    spos = strstr(ss,".NTO");
	    spos1 = strstr(ss,".NFO");
	    if(spos == NULL && spos1 == NULL){
//	       fprintf(fp_out,"%s\n",ss);
//	       printf("before 1 COMPLETE_MEMORY_LINE is=%d k=%d i_dep=%d j_dep=%d \n",is,k,i_dep,j_dep);
               COMPLETE_MEMORY_LINE(ss,&is,&k,&i_dep,&j_dep,ss_mem,nb,\
               nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	       s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
	       klik,extrm);
//	       printf("after 1 COMPLETE_MEMORY_LINE is=%d k=%d i_dep=%d j_dep=%d \n",is,k,i_dep,j_dep);
	    }else{//if(spos == NULL){
	       l=-1;
	       if(spos != NULL){
	          l= spos - ss;
	       }else{//if(spos != NULL){
	          l= spos1 - ss;
	       }//if(spos != NULL){
	       icode = 0;
	       j=0;
	       if (l > 0){// detection of blancs before which are accepted
	          while(icode == 0 && j < l){
		     if(ss[j] != ' ')icode = 1;
		     ++j;
	          }//while(icode = 0 && j < l){
	       }//if (l > 0){
	       if(icode == 0){// print a separation
	          c = '_';
		  for(j= 0 ; j < 30 ; ++j)ss[j] = c;
		  ss[j]='\0';
/*	          fprintf(fp_out,"%s\n",ss);
	          fprintf(fp_out,"\n");*/
/*		  printf("Print a separation \n");
		  printf("before COMPLETE_MEMORY_LINE is=%d k=%d i_dep=%d j_dep=%d \n",is,k,i_dep,j_dep);*/
                  COMPLETE_MEMORY_LINE(ss,&is,&k,&i_dep,&j_dep,ss_mem,nb,\
		  nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
		  s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
		  klik,extrm);
		  strcpy(ss,"   ");
                  ADD_DISPLAY_SINGLE_LINE(ss,&is,&k,&i_dep,&j_dep,&lb,ss_mem,nb,\
		  nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
		  s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
		  klik,extrm);
//		  printf("after COMPLETE_MEMORY_LINE is=%d k=%d i_dep=%d j_dep=%d \n",is,k,i_dep,j_dep);
		  strcpy(ss_mem[is],"   ");
	       }else{//if(icode == 0){
//	          fprintf(fp_out,"%s\n",ss); // not .NTO
                  COMPLETE_MEMORY_LINE(ss,&is,&k,&i_dep,&j_dep,ss_mem,nb,\
		  nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
		  s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
		  klik,extrm);
	       }//if(icode == 0){
	    }//if(spos == NULL){
/*
 *   End detection of .NTO and otherwise writing of line
 */
	    ++n_line;
//	    nc0=-1;
	 }else{/*if(nb_lu >= 0){*/
//	    if(ndeb == 0)fprintf(fp_out,"\n"); /* terminate preceeding line */
/*	    if(lb < 3 && ndeb == 0 && inp == 0)\
	                           fprintf(fp_out,"\n");*/ /* + white line */
//	    printf("Terminate page ndeb=%d lb=%d inp=%ld \n",ndeb,lb,inp);
	    ss_mem[is][0]='\0'; // because we always have blancs inserted
	                        // at beginning of ss_mem and 
	// ADD_DISPLAY_SINGLE_LINE then close it and add still another line 
	    if(lb < 2  ){
		  strcpy(ss," ");
                  ADD_DISPLAY_SINGLE_LINE(ss,&is,&k,&i_dep,&j_dep,&lb,ss_mem,nb,\
		  nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
		  s1_word,s1_klik,scroll_bzh,dico_b,iappel,&ib,stgs_dico,\
		  klik,extrm);
	    }//if(lb < 3 && ndeb == 0 && inp == 0){
//	    ++lb;
//	    nc0=-1;
	    nb_lu=-2;
	 }/*if(nb_lu >= 0){*/
	 ++i;
//	 printf("i=%ld \n",i);
      }/* while(nc <= li1[1]){*/
	    ss_mem[is][0]='\0'; // because we always have blancs inserted
   }/*if(li1[0] > 0){*/
/*
 *    End of lecture
 */
/*printf("EXTRACT4_ONE_PAGE Every line has been read now flush remaining memory \n");
      fflush(stdout);*/
/*      printf("Flush if k > 0   k=%d  i_dep=%d \n",k,i_dep);
      if(k > 0 ){
         i_fin = i_dep+k-1 ;
            DUMP_SS_MEM ( ss_mem,i_dep, i_fin);
              FLUSH_SS_MEM(&i_dep,&j_dep,i_fin,ss_mem,nb,nb0, \
              posit,pos_db,fp1,fph,box1,lbox2,w_loop1, \
              s1_col,s1_word,s1_klik,scroll_bzh,dico_b, \
              iappel,&ib,stgs_dico,klik,extrm) ;
      }*//*  if(k > 0 ){*/
/*
 *   Leaving with a FLUSH
 */
//             printf("EXTRACT4_ONE_PAGE leaving flush \n");
              CALL_FLUSH_SS_MEM(&i_dep,&j_dep,is,ss_mem,nb,nb0, \
              posit,pos_db,fp1,fph,box1,lbox2,w_loop1, \
              s1_col,s1_word,s1_klik,scroll_bzh,dico_b, \
              iappel,&ib,stgs_dico,klik,extrm) ;
	   
   if(n_line > 0)page_found = 1;
   free(ss);
   fclose(fp1) ;
   fclose(fph) ;
   g_free(w_loop1);
   return(page_found);
} /**  end of EXTRACT_ONE_PAGE   */
/**********************************************************************/
void OUT_STRING_BOOK1 ( long int nch0, long int nch1, char *s,\
      int *nc0,int nc,int *lb, int *n_line,\
      int *it,int *kt,int *it_dep,int *jt_dep,\
      char ss_mem[][100], int nb, int nb0, \
 long posit[] , long pos_db[] , FILE *fp1, FILE *fph, GtkWidget *box1,\
 GtkWidget *lbox2[],W_loop *w_loop1,\
  char s1_col[], char s1_word[],\
  char s1_klik[],GtkWidget *scroll_bzh,  GtkWidget *dico_b, \
   int iappel,int *ib ,  \
  Trf_string *stgs_dico,Trf_klik *klik[],Trf_extrm *extrm)  
/*
 *   Write string s on the file fp_out as if it was to put it on
 *   the book part of FURCH
 *   Only the string from nch0 to nch1 (included) is written
 *   nc is the number of characters we want to have on each line.
 *   For BOOK1 we always start the line at character position 0.
 *   lb is the number of blanc lines already written.
 *   nline is the number of lines already written.
 */
{   /****  ==================================    */
char  BFE,c   ;
long nc1,nc2   ;
int i,j,j1,k,l,ic ;
int ncm,lstop,iup,jback;
FILE *fp_out;
/*fp = fopen("dicovb","r") ;*/
/*fp = fopen(inFile,"r") ;
fpi = fopen("./ww_net","w+") ;*/
/*********************************************************/
//nc = 70 ;
/*printf("Enter OUT_STRING_BOOK1 lb=%d nline=%d s=%s@@@\n",*lb,*n_line,s);
printf("Write s from nch0=%ld  to nch1=%ld  Already written nc0=%d \n",nch0,nch1,*nc0);*/
if(nch0 > nch1 ){
   printf("error 55 OUT_STRING_BOOK1 nch0 > nch1 \n");
   exit(55);
}//if(nch0 > nch1 ){
if(nc < 20 )nc=20;
nc1=nc+2;
nc2=nc+nc;
ncm=nc-20;
if(ncm < 10)ncm=10;
i=0 ;
BFE = 'E';

if (s != NULL  ) {
	l=strlen(s);
	if(l <= 0) {
		 *lb = *lb+1;
//	         printf("OUTPUT l<= 0  *lb=%d \n",*lb);
		 if(*lb < 3){
	            *n_line = *n_line+1;
		    fprintf(fp_out,"\n");
		 }/*if(*lb < 3){*/
	   return;
	}/* if(l <= 0) {*/
/*	printf("\n");
	printf("enter OUT_STRING_BOOK1 s=%s@@@@ \n",s);*/
	k=nch0;
	while(s[k] == ' ' && k <= nch1)++k;
	i= k ;
	lstop = 0 ;
	while(lstop == 0){
	   j = 0 ;
/*	   BFE='|';
	   printf("s[i]=%c  = %d  BFE=%d \n",s[i],s[i],BFE);*/
//	   while (c = s[i+j] && j < n1 && (SPE_ALPHA_NUM(s[i+j]) )++j;
           if(i+j > nch1)break;
           c= s[i+j];
	   ic=c;
//	   if(ic == -96 || ic == 160 || iscntrl(c)){
	   if(ic == -96 || ic == 160 ){
	      c=' ';
	      s[i+j]=c;
	      ic=c;
	   }/*if(ic == -96 || ic == 160){*/
	   while ( i+j < nch1 && j < nc2-nc1 && (SPE_ALPHA_NUM(c) || SPE_PUNCTU(c) )){
	      ++j;
              c= s[i+j];
	      ic=c;
	      if(ic == -96 || ic == 160 ){
	         c=' ';
	         s[i+j]=c;
	         ic=c;
	      }/*if(ic == -96 || ic == 160){*/
	   }/*while ( j < n1 && (SPE_ALPHA_NUM(c) ||*/
	   k=i;
	   while(k <= nch1 && s[k] == ' ')++k;
	   if(s[i+j] == '\0' ){
/*	    printf(" OUT_STRING_BOOK1 fin ligne i=%d j=%d k = %d\n",i,j,k); 
	      printf("OUT_STRING_BOOK1 s=%s@@@ \n",s+i);*/
	      if(strcspn(s+k," ")){/** if that case we have non space char */
//	         printf("OUT_STRING_BOOK1 autre que blancs \n");
		 if(nc  == nc1 || nch0 > 0){
	            *n_line = *n_line+1;
	            fprintf(fp_out,"%s\n",s+k);
		 }else{/*if(nc  == nc1){*/
	            *n_line = *n_line+1;
	            fprintf(fp_out,"  %s\n",s+k);
		    nc1=nc;
		 }/*if(nc  == nc1){*/
		 *lb = 0 ;
	      }else{//if(strcspn(s+k,' ')){
		 *lb = *lb+1;
//	         printf("OUT_STRING_BOOK1 rien que blancs lb=%d \n",*lb);
		 if(*lb < 3){
	            *n_line = *n_line+1;
		    fprintf(fp_out,"\n");
		 }/*if(*lb < 3){*/
		 if(nc1 != nc)nc1=nc;
	      }//if(strcspn(s+k,' ')){
		 lstop=1;
	   }else{ /* if(s[i+j] == '\0'){*/
//	      if(ic == -96 || ic == 160 || iscntrl(c)){
	      if(ic == -96 || ic == 160 ){//trial 23-01-2008
	         s[i+j]=' ';
//		 --j;
	      }/*if(iscntrl(s[i+j])){*/
//1-Dec-2006  while((i+j) >= nch0 && s[i+j] != ' ' && j >= ncm )--j;/*look for first blanc*/
	      jback=0;
	      c= s[i+j];
	      while(j >= 0 && c != ' ' && c != '/' && c != '\\' && jback  <= ncm){
	          --j;/*look for first blanc*/
		  c = s[i+j];
		  ++jback;
	      }/*   end of while(j > 0  */

/*	      while((i+j) >= nch0 && j > nc)--j;
              c=s[i+j];
	      while(c != ' ' && c != '/' && c != 92 && !ispunct(c) && j >= ncm){
	         --j;
                 c=s[i+j];
	      }*//*while(c != ' ' && j >= ncm){*/
	      j1= i+j;
	      c = s[j1];
	      ic = c;
              while((i+j) > nch0 && (c == ' ' || c == '<' || ic == 34 || ic == 39 ||\
	       ic == 171 || ic == 173 || ic == 151 || ic == '(' || c == '-')){
	         --j;
	         j1= i+j;
	         c = s[j1];
	         ic = c;
	      }
//1-Dec-2006  j1 = i+j+2;
	      ++j ; //  ????????
	      j1 = i+j+1;
	      c = s[j1];  
	      ic = c;
//	      printf("OUT_STRING_BOOK1 after first blanc ligne %d  j1=%d c=%c ic=%d \n",*n_line,j1,c,ic);
/*	      if(s[i+j] == ' ' && ispunct(c) && c != '<' && ic != 38 \
	        && ic != 114 && ic != 171 && c != '(' )j= j1+1;*/
	      iup=0;
	      if(s[i+j] == ' '){
	         while( j1 <= nch1 && ispunct(c) && c != '<' &&\
		 !(ic == 34 && iup== 0) && !(ic == 39 && iup == 0)\
	          && ic != 171 && ic != 173 && ic != 151 &&\
		 c != '('  && c != '-' ){
		    ++j1;
		    ++iup;
	            c = s[ j1];
	            ic = c;
//	            printf("OUT_STRING_BOOK1 ligne %d  j1=%d c=%c ic=%d \n",*n_line,j1,c,ic);
	         }/*while( ispunct(c) && c != '<' && ic != 38 \*/
		 j=j1-i;
	      }/*if(s[i+j] == ' '){*/
	 /*     printf(" milieu ligne i=%d j=%d \n",i,j) ;*/
//	      j=j1-i;
	      BFE = s[i+j];
	      s[i+j] = '\0';
	   /*   printf("%s\n",s+i);*/
//	      fprintf(fp_out,"%s\n",s+k);
		 if(nc  == nc1 || nch0 > 0){
	            *n_line = *n_line+1;
	            fprintf(fp_out,"%s\n",s+k);
		 }else{/*if(nc  == nc1){*/
	            *n_line = *n_line+1;
	            fprintf(fp_out,"  %s\n",s+k);
		    nc1=nc;
		 }/*if(nc  == nc1){*/
	      i = i+j ;
	      s[i] = BFE;
	      if(i >= l )lstop=1;
	   } /* if(s[i+j] == '\0'){*/
	} /*while(l == 0){*/
} /*** end of if s != NULL  ***/
}
/**********************************************************************/
void OUT_STRING_BOOK2 ( long int nch0, long int nch1, char *s,\
      int *nc0,int nc,int *lb, int *n_line,\
      int *it,int *kt,int *it_dep,int *jt_dep,\
      char ss_mem[][100], int nb, int nb0, \
 long posit[] , long pos_db[] , FILE *fp1, FILE *fph, GtkWidget *box1,\
 GtkWidget *lbox2[],W_loop *w_loop1,\
  char s1_col[], char s1_word[],\
  char s1_klik[],GtkWidget *scroll_bzh,  GtkWidget *dico_b, \
   int iappel,int *ib ,  \
  Trf_string *stgs_dico,Trf_klik *klik[],Trf_extrm *extrm)  
/*
 *    We write s from nch0 (included) to nch1 (included)
 *    Writing of the character string s in lines of nc characters long
 *    nc0 characters have been already written in ss_mem[it]
 *    write in ss_mem[it] at start of sub
 *    We are writing at ss_mem[it] when living. It is not the next line
 *    For furch word start at it_dep, jt_dep
 *    we count also nb the number of blanc lines 
 *    and n_line the number of lines already written
 *    Note : A "separator" (line of the same character) is always
 *    followed by a blanc line
 */
{   /****  ==================================    */
char  BFE , c  ;
unsigned char c1;
char swork[101];
long nc1,nc2   ;
int i,j,jmem,j1,k,l,ic,iup,jt ;
int ncm,nccm,ncr,lstop,jback;
int iwhite_line;
/*fp = fopen("dicovb","r") ;*/
/*fp = fopen(inFile,"r") ;
fpi = fopen("./ww_net","w+") ;*/
/*********************************************************/
//nc = 70 ;
/*printf("Enter OUT_STRING_BOOK2 lb=%d nline=%d s=%s@@@\n",*lb,*n_line,s);
printf("Write s from nch0=%ld  to nch1=%ld  Already written nc0=%d \n",nch0,nch1,*nc0);
printf("OUT_STRING_BOOK2 level enter ; for FURCH_WORDS it_dep=%d  jt_dep=%d \n",
		*it_dep,*jt_dep);
printf("OUT_STRING_BOOK2 level enter write in ss_mem[%d] nb lignes actives  kt=%d \n",
		*it,*kt);*/
if(nch0 > nch1 ){
//   printf("OUT_STRING_BOOK2 nch0 > nch1 call COMPLETE_MEMORY_LINE \n");
   swork[0]='\0';
   COMPLETE_MEMORY_LINE(swork,it,kt,it_dep,jt_dep,ss_mem,nb,\
   nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
   s1_word,s1_klik,scroll_bzh,dico_b,iappel,ib,stgs_dico,\
   klik,extrm);
   if(*it_dep == *it)*jt_dep = 0;
   *nc0=strlen(ss_mem[*it])-1; // shoud be equal to -1
   return;
//   exit(55);
}//if(nch0 > nch1 ){
if(nc < 20 )nc=20;
nc1 = nc;
if(*nc0 < 0){ /* We suppose we start a new paragraph */
   nc1=nc+2; 
   *nc0=0;
}/*if(*nc0 == 0)*/
nc2=nc+nc;
//ncm = 25 ; /*** maximum of backward search for a blanc ****/
ncm=nc-20;
if(ncm < 10)ncm=10;
ncr=nc ; /**  maximum number of reapeated character  **/
//ncm=nc-20;
//if(ncm < 10)ncm=10;
i=0 ;
BFE = 'E';

/*	printf("\n");
	printf("enter OUT_STRING_BOOK2already written nc0=%d s=%s@@@@ \n",*nc0,s);*/
if (s != NULL  ) {
	l=strlen(s);
/*
 *    Case we have a white line
 */
    iwhite_line=1;
    if(*nc0 > 0 ) {
      i=0;
      while(iwhite_line == 1 && i <= *nc0){
         c= s[i];
         if(c != ' ' )iwhite_line = 0;
         ++i;
      }//while(iwhite_line == 0 & i <= *nc0){
    }//if(*nc0  > 0 ) {
    if(l > 0 ) {
      i=0;
      while(iwhite_line == 1 && i < l){
         c= s[i];
         ic= (int) c;
         if(c != ' ' && c !='|' && ic != -96 && ic != 160  )iwhite_line = 0;
         ++i;
      }//while(iwhite_line == 0 & i < l){
    }//if(l > 0 ) {
//    printf("OUT_STRING_BOOK2 iwhite_line =%d \n",iwhite_line);

        j=0;
	if(l <= 0 || nch1 < 0 || iwhite_line == 1) {
//	         printf("OUT_STRING_BOOK2 we have a white line  l<= 0  *lb=%d \n",*lb);
		 if(*lb < 2){
	            *n_line = *n_line+1;
//	            printf("OUT_STRING_BOOK2 white line call ADD_DISPLAY_SINGLE_LINE \n");
		     /*     fprintf(fp_out,"\n");
		          fprintf(fp_out,"\n");*/
		/*  Attention pour OUT_STRING_BOOK2  on avait fait ++it 
		 *  alors que l'on a rien sur la nouvelle ligne. Mais
		 *  ADD_DISPLAY_SINGLE_LINE ferme cette nouvelle ligne
		 *  et rajoute une autre ici blanche !
		 */
		jt= *it-1;
		if (jt <= 0)jt=jt+ISS_MAX;
//		printf("before ADD_DISPLAY change it=%d into jt=%d \n",*it,jt);
		*it=jt;
		          strcpy(swork,"     ");
                ADD_DISPLAY_SINGLE_LINE(swork,it,kt,it_dep,jt_dep,lb,ss_mem,nb,\
		  nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
		  s1_word,s1_klik,scroll_bzh,dico_b,iappel,ib,stgs_dico,\
		  klik,extrm);
/*		printf("OUT_STRING_BOOK2 levelwhite line after ; it_dep=%d  jt_dep=%d\n",\
		*it_dep,*jt_dep);*/
		 *nc0 = strlen(ss_mem[*it])-1;
	                  *n_line = *n_line+1; // terminate+new line = 2
		 }else{/*if(*lb < 3){*/
		   *lb = *lb+1;
		 }/*if(*lb < 3){*/
//	   *nc0=-1;// We will start a new paragraph 
//	   printf("Quit 1 OUT_STRING_BOOK2 lb=%d nline=%d \n",*lb,*n_line);
	   return;
	}/* if(l <= 0) {*/
	k=nch0;
	while(s[k] == ' ' && k < nch1)++k;
	i= k ;
/*
 *    Problem of a line beginning by the same character reapeated
 *    more than ncr times
 */
        c= s[i];
        while(k < l && s[k]== c && k < nch1)++k;
	if((k-i) >= ncr){/*  use that line as a separation */
//	  printf("OUT_STRING_BOOK2  separator i=%d k=%d  \n",i,k);
	  j=k;
	  if(j > i+nc ) j=i+nc;
	  s[j]='\0';
	  if(*nc0 > 0 ){
//	      fprintf(fp_out,"\n");/*** terminate preceding line + display
//	                                   s + i **/
//	      printf("separator call 1 ADD_DISPLAY_SINGLE_LINE j=%d \n",j);
//	      printf("separator call 1 it_dep=%d  jt_dep=%d it=%d\n",*it_dep,*jt_dep,*it);
              ADD_DISPLAY_SINGLE_LINE(s+i,it,kt,it_dep,jt_dep,lb,ss_mem,nb,\
	      nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	      s1_word,s1_klik,scroll_bzh,dico_b,iappel,ib,stgs_dico,\
	      klik,extrm);
//	      printf("separator after call 1 it_dep=%d  jt_dep=%d it=%d\n",*it_dep,*jt_dep,*it);
	      *n_line = *n_line+1;
	      *lb=0;
	      *nc0 = -1;
	  }else{/*if(*nc0 > 0 ){*/
//	      printf("OUT_STRING_BOOK2 separator call 1 COMPLETE_MEMORY_LINE \n");
              COMPLETE_MEMORY_LINE(s+i,it,kt,it_dep,jt_dep,ss_mem,nb,\
              nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
              s1_word,s1_klik,scroll_bzh,dico_b,iappel,ib,stgs_dico,\
              klik,extrm);
	      ss_mem[*it][0]='\0';
	      *nc0 = -1;
	  }/*if(*nc0 > 0 ){*/
//	  fprintf(fp_out,"%s\n",s+i);
/*           printf("separator before call 2 ADD_DISPLAY_SINGLE_LINE \n");
	      printf("separator call 2 it_dep=%d  jt_dep=%d it=%d\n",*it_dep,*jt_dep,*it);
            DUMP_SS_MEM ( ss_mem,*it_dep, *it);*/
          strcpy(swork,"     ");
              ADD_DISPLAY_SINGLE_LINE(swork,it,kt,it_dep,jt_dep,lb,ss_mem,nb,\
	      nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	      s1_word,s1_klik,scroll_bzh,dico_b,iappel,ib,stgs_dico,\
	      klik,extrm);
/*
 *   for a blanc line ADD_DISPLAY_SINGLE_LINE makes a FLUSH_MEMORY
 *   so is should be is= 1 so no pb for the number of lines
 */
               strcpy(ss_mem[*it],"     ");
/*	       if(*lb <=2){
	          *it = *it +1;
		  if(*it > ISS_MAX)*it=*it-ISS_MAX;
		  ss_mem[*it][0]='\0';
	       }*///if(lb <=2){
/*           printf("separator after call 2 ADD_DISPLAY_SINGLE_LINE \n");
	      printf("separator after call 2 it_dep=%d  jt_dep=%d\n",*it_dep,*jt_dep);
            DUMP_SS_MEM ( ss_mem,*it_dep, *it);*/
	  *n_line = *n_line+1; // terminate+new line = 2
	  *nc0=5;
	  *lb=0;
	  s[j]=c;
	  if(k >= l)return;
	  i=k;
//	  printf("leaving separator i=%d \n",i);
	}/*if((k-i) >= ncr){*/
/*
 *     end of repeated char
 */
	lstop = 0 ;
	while(lstop == 0){ /* main loop through the string starting from i */
//	   printf("OUT_STRING_BOOK2 main loop through the string starting from i=%d \n",i);
/*	   printf("OUT_STRING_BOOK2 loop lstop level 0  s[%d]=%s@@@\n",i,s+i);
	   printf("s+i=%s@@@ \n",s+i);*/
	   j = 0 ;
/*	   BFE='|';
	   printf("s[i]=%c  = %d  BFE=%d \n",s[i],s[i],BFE);*/
//	   while (c = s[i+j] && j < n1 && (SPE_ALPHA_NUM(s[i+j]) )++j;
           if(i+j >= nch1)break;
           c= s[i+j];
	   ic= (int) c;
//	   if(ic == -96 || ic == 160 || iscntrl(c)){
	   if(ic == -96 || ic == 160 ){
	      c=' ';
	      s[i+j]=c;
	      ic= (int) c;
	   }/*if(ic == -96 || ic == 160){*/
/*         nc2-nc1 is almost equal to nc */
//	   while ( j < nc2-nc1- (*nc0) && (SPE_ALPHA_NUM(c) || c == ' ' || ispunct(c) )){
/*           printf("level -1  l=%d  nc2-nc1-nc0=%ld \n",l,nc2-nc1- (*nc0));
           printf("level -1.1  nc0=%d nc1=%ld nc2=%ld \n",*nc0,nc1,nc2);
	   printf("level -1.2 s[i]=%s@@@ \n",(s+i));*/
// 27 avril 2007 modif i+j <= nch1 compt number of char
           nccm = nc2-nc1 -(*nc0);
//	   printf("before loop while nccm=%d i+j=%d l=%d \n",nccm,i+j,l);
//	   if(nch1 == l-1)nch1=l;
	   while ( i+j < nch1 && j < nccm &&\
	    (SPE_ALPHA_NUM(c) || SPE_PUNCTU(c) ) && i+j < l){
	      ++j;
              c= s[i+j];
	      ic= (int) c;
/*	      printf("j=%d c=%c ic=%d TRUE_SPN=%d TRUE_ispunct=%d\n",j,c,ic,\
	         (SPE_ALPHA_NUM(c)  ),ispunct(c)  );*/
//	         (SPE_ALPHA_NUM(c) || c == ' ' || ispunct(c) )  );
	      if(ic == -96 || ic == 160 ){
	         c=' ';
	         s[i+j]=c;
	         ic= (int) c;
	      }/*if(ic == -96 || ic == 160){*/
	   }/*while ( j < n1 && (SPE_ALPHA_NUM(c) ||*/
//	   printf("after loop while nccm=%d i+j=%d l=%d \n",nccm,i+j,l);
	   if(j == 0 ) ++j;
/******  k is the beginning of s and it has probably been adjusted  */
	   k=i;
	   while(k < nch1 && s[k] == ' ')++k;
//	   printf("OUT_STRING_BOOK2 loop lstop level 1 write s from k=%d to j=%d \n",k,j);
/******  end adjustment of k    **/
//         printf("write s from k=%d to j=%d \n",k,j);
	   if(s[i+j] == '\0' ){
/******   We are at the end of the string s      */
/*	    printf(" OUT_STRING_BOOK2 end of line i=%d j=%d k = %d\n",i,j,k); 
	    printf("OUT_STRING_BOOK2 level A1 s+i=%s@@@ \n",s+i);*/
	      --j;
	      while(s[i+j] == ' ')--j;
	      if(strcspn(s+k," ")){/** if that case we have non space char */
//	         printf("OUTPUT something else than blancs \n");
		 if(nc  == nc1 || nch0 > 0 ){
        /***  we can complete the line and not worry for the 2 blancs   ***/
		    if(j >= (nc2-nc1 - (*nc0))){ 
//		        printf("We complete the line \n");
	               *n_line = *n_line+1;
//	               fprintf(fp_out,"%s\n",s+k);
//	      printf("OUT_STRING_BOOK2 call 2 COMPLETE_MEMORY_LINE \n");
              COMPLETE_MEMORY_LINE(s,it,kt,it_dep,jt_dep,ss_mem,nb,\
              nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
              s1_word,s1_klik,scroll_bzh,dico_b,iappel,ib,stgs_dico,\
              klik,extrm);
		       *nc0=0;
		       *lb=0;
		    }else{/*if(j >= *nc2-nc1 - *nc0){ */
/*		       printf(" line not complete j= %d >= nc2-nc1-nc0 = %ld s+k=%s@@ \n",\
		         j, nc2-nc1- (*nc0),s+k);*/
		          if(s[i+j] != '-'){
//			     fprintf(fp_out,"%s ",s+k);
                             ADD_TO_MEMORY_LINE(s+k,*it,ss_mem);
			     strcpy(swork," ");
                             ADD_TO_MEMORY_LINE(swork,*it,ss_mem);
		             *nc0 = *nc0+i+j-k+1;
			  }else{//if(s[i+j] != '-'){
//			     fprintf(fp_out,"%s",s+k);
                             ADD_TO_MEMORY_LINE(s+k,*it,ss_mem);
//                           printf("Call 2 ADD_TO_MEMORY_LINE \n");
		             *nc0 = *nc0+i+j-k;
			  }//if(s[i+j] != '-'){
		       *lb=0;
		    }/*if(j >= *nc2-nc1 - *nc0){ */
		 }else{/*if(nc  == nc1){*/
        /***  we can complete the line but we have 2 blancs   ***/
//	            printf(" We complete the line but we have 2 blancs  \n");
		    if(j >= (nc2-nc1 - (*nc0))){ 
//		       printf("Output line is also complete \n");
	               *n_line = *n_line+1;
		       if(*nc0 == 0){
//	                  fprintf(fp_out,"  %s\n",s+k);
			  strcpy(swork,"  ");
                          ADD_TO_MEMORY_LINE(swork,*it,ss_mem);
//	      printf("OUT_STRING_BOOK2 call 3 COMPLETE_MEMORY_LINE \n");
              COMPLETE_MEMORY_LINE(s+k,it,kt,it_dep,jt_dep,ss_mem,nb,\
              nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
              s1_word,s1_klik,scroll_bzh,dico_b,iappel,ib,stgs_dico,\
              klik,extrm);
		       }else{/*if(*nc0 == 0){*/
//	                  fprintf(fp_out,"%s\n",s+k);
//	      printf("OUT_STRING_BOOK2 call 4 COMPLETE_MEMORY_LINE \n");
              COMPLETE_MEMORY_LINE(s+k,it,kt,it_dep,jt_dep,ss_mem,nb,\
              nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
              s1_word,s1_klik,scroll_bzh,dico_b,iappel,ib,stgs_dico,\
              klik,extrm);
		       }/*if(*nc0 == 0){*/
		       nc1=nc;
		       *nc0 = 0;
		       *lb=0;
		    }else{/*if(j >= *nc2-nc1 - *nc0){ */
//		       printf("Output line is not complete \n");
		       if(*nc0 == 0){
			     if(s[i+j] != '-'){
//			        fprintf(fp_out,"  %s ",s+k);
			  strcpy(swork,"  ");
                          ADD_TO_MEMORY_LINE(swork,*it,ss_mem);
                          ADD_TO_MEMORY_LINE(s+k,*it,ss_mem);
			  strcpy(swork," ");
                          ADD_TO_MEMORY_LINE(swork,*it,ss_mem);
		                *nc0 = *nc0+i+j-k+3;
			     }else{//if(s[i+j] != '-'){
//			        fprintf(fp_out,"  %s",s+k);
			  strcpy(swork,"  ");
                          ADD_TO_MEMORY_LINE(swork,*it,ss_mem);
                          ADD_TO_MEMORY_LINE(s+k,*it,ss_mem);
		                *nc0 = *nc0+i+j-k+2;
			     }//if(s[i+j] != '-'){
			  *lb=0;
		       }else{/*if(*nc0 == 0){*/
//????	                  fprintf(fp_out,"%s \n",s+k);
			     if(s[i+j] != '-'){
//			        fprintf(fp_out,"%s ",s+k);
                             ADD_TO_MEMORY_LINE(s+k,*it,ss_mem);
			     strcpy(swork," ");
                             ADD_TO_MEMORY_LINE(swork,*it,ss_mem);
		                *nc0 = *nc0+i+j-k+1;
			     }else{//if(s[i+j] != '-'){
//			        fprintf(fp_out,"%s",s+k);
                             ADD_TO_MEMORY_LINE(s+k,*it,ss_mem);
		                *nc0 = *nc0+i+j-k;
			     }//if(s[i+j] != '-'){
			  *lb=0;
		       }/*if(*nc0 == 0){*/
		       nc1=nc;
		    }/*if(j >= *nc2-nc1 - *nc0){ */
//		    if(*nc0 >= nc)*nc0=0;
		 }/*if(nc  == nc1){*/
		 *lb = 0 ;
//		 printf("We enforce lb=%d \n",*lb);
	      }else{//if(strcspn(s+k,' ')){ We have only space char 
		 *lb = *lb+1;
//	         printf("OUT_STRING_BOOK2 only blancs lb=%d \n",*lb);
		 if(*lb < 2){
	            *n_line = *n_line+1;
//		       fprintf(fp_out,"\n");
			  strcpy(swork,"   ");
              ADD_DISPLAY_SINGLE_LINE(swork,it,kt,it_dep,jt_dep,lb,ss_mem,nb,\
	      nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
	      s1_word,s1_klik,scroll_bzh,dico_b,iappel,ib,stgs_dico,\
	      klik,extrm);
	            *nc0 = -1;
		 }/*if(*lb < 3){*/
/*****   in that case we begin a new paragraph     ****/
		  *nc0=-1;
		  return;
	      }//if(strcspn(s+k,' ')){
		 lstop=1;
/******   End of : We are at the end of the string s      */
	   }else{ /* if(s[i+j] == '\0'){*/
/******   Start of : We are not at the end of the string s      */
/*           printf("OUT_STRING_BOOK2 with i+j=%d we are not at end of string \n",i+j);
	     printf("s+i+j=%s@@@ \n",s+i+j);*/
//	      if(ic == -96 || ic == 160 || iscntrl(c)){
	      if(ic == -96 || ic == 160 ){//trial 23-01-2008
	         s[i+j]=' ';
//		 --j;
	      }/*if(iscntrl(s[i+j])){*/
//	      printf("level 0 i=%d k=%d j=%d \n",i,k,j);
	      /*look for first backward blanc*/
	      jback=0;
	      c= s[i+j];
//	      printf("Look for first backward blanc s[i+j]=%c ",s[i+j]);
	      if(j >= nccm){
	      jmem=j;
	      while(j >= 0 && c != ' ' && c != '/' && c != '\\' && jback  <= ncm){
	          --j;/*look for first blanc backward */
		  c = s[i+j];
		  ++jback;
	      }/*   end of while(j > 0  */
//??	      if(j <=0 && jmem > 0)j=jmem;
	      }//if(j >= nccm){
//	      printf("level 1 i=%d k=%d j=%d \n",i,k,j);
	      if(j <= 0){/** case we have not been able to add a character */
	      //   We terminate the preceding line 
//		 printf("oblijed terminate preceding line \n");
	         *n_line = *n_line+1;
		 j=0;
//	         fprintf(fp_out,"\n");
//	      printf("OUT_STRING_BOOK2 call 5 COMPLETE_MEMORY_LINE \n");
	         strcpy(swork," ");
              COMPLETE_MEMORY_LINE(swork,it,kt,it_dep,jt_dep,ss_mem,nb,\
              nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
              s1_word,s1_klik,scroll_bzh,dico_b,iappel,ib,stgs_dico,\
              klik,extrm);
		 *nc0=0;
		 *lb=0;
	         continue;
	      }/*if(j == 0){ obliged terminate line */
/*
 *    j was the first blanc we continue to decrease for all the blancs 
 *    for < " ' <<  --
 *    34 = "
 */
//	     printf("backward 1 s+i+j=%s@@@ \n",s+i+j);
	      j1= i+j;
	      c = s[j1];
	      ic = (int) c;
/*              while(j > 1 && (c == ' ' || c == '<' || ic == 34 || ic == 39 ||\
	       ic == 171 || ic == 173 || ic == 151 || ic == '(' || c == '-')){*/
              while(j > 1 && (c == ' ' || OPEN_PAR(c) || ic == 34 || ic == 39 ||\
	       ic == 171 || ic == 173 || ic == 151  || c == '-')){
	         --j;
//		 printf("level pre-2 j=%d \n",j);
	         j1= i+j;
	         c = s[j1];
	         ic = (int) c;
	      }
	      ++j;
//	      printf("level 2 i=%d k=%d j=%d \n",i,k,j);
	      j1 = i+j+1;
	      c = s[j1];  
	      ic =  (int) c;
/*
 *   At that level  s[i+j] was the last down process
 *   j1 = i+j+1
 */
//	      printf("OUTPUT after first blanc ligne %d  j1=%d c=%c ic=%d \n",*n_line,j1,c,ic);
/*	      if(s[i+j] == ' ' && ispunct(c) && c != '<' && ic != 38 \
	        && ic != 114 && ic != 171 && c != '(' )j= j1+1;*/
/*
 *   We restart up in some cases for example add the punctuation
 */
/*             printf("OUT_STRING_BOOK2 level B1 before restart up \n");
	     printf("s+i+j=%s@@@ \n",s+i+j);
	     printf("s+i+j-1=%s@@@ \n",s+i+j-1);*/
/*	            c = s[i+j];
	            ic = c;*/
//	     printf("i+j=%d  c=%c  ic=%d  \n",i+j,c,ic);
              iup=0;
	      if(s[i+j] == ' '){
//	         printf("OK for start upward ispunct(c)=%d \n",ispunct(c));
/*	         while( j1 < nch1 && ispunct(c) && c != '<' &&\
		 !(ic == 34 && iup == 0) && !(ic == 39 && iup == 0)\
	         && ic != 171 && ic != 173 && ic != 151 &&\
		 c != '('  && c != '-' ){*/
	         while( j1 < l && ispunct(c)  &&\
		 !(ic == 34 && iup== 0) && !(ic == 39 && iup == 0)\
	         && ic != 171 && ic != 173 && ic != 151 &&\
		  c != '-' && !OPEN_PAR(c)){
		    ++j1;
		    ++iup;
	            c = s[j1];
	            ic = (int) c;
//	            printf("OUTPUT ligne %d  j1=%d c=%c ic=%d \n",*n_line,j1,c,ic);
	         }/*while( ispunct(c) && c != '<' && ic != 38 \*/
		 j=j1-i;
	      }else{/*if(s[i+j] == ' '){*/
// modif april 30 2007  
	         ic= (int) s[i+j];
		 c=s[i+j-1];
		 c1=s[i+j];
		 if( (ispunct(c1) || CURRENCY(c1) ) && (isalnum(c) || c == ' '))++j;
	      }/*if(s[i+j] == ' '){*/
	      
	 /*     printf(" milieu ligne i=%d j=%d \n",i,j) ;*/
	      if(j <= 1 ) j=1;
	      BFE = s[i+j];/* put char in memory   */
	      s[i+j] = '\0';
//	      printf("level 3 i=%d k=%d j=%d \n",i,k,j);
	   /*   printf("%s\n",s+i);*/
		 if(nc  == nc1){
	            *n_line = *n_line+1;
//	            fprintf(fp_out,"%s\n",s+k);
//	    printf("OUT_STRING_BOOK2 call 1 COMPLETE_MEMORY_LINE it=%d kt=%d it_dep=%d jt_dep=%d  \n",*it,*kt,*it_dep,*jt_dep);
/*	      printf("OUT_STRING_BOOK2 call 6 COMPLETE_MEMORY_LINE nc=nc1=%d\n",nc);
            DUMP_SS_MEM ( ss_mem,*it_dep, *it);*/
              COMPLETE_MEMORY_LINE(s+k,it,kt,it_dep,jt_dep,ss_mem,nb,\
              nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
              s1_word,s1_klik,scroll_bzh,dico_b,iappel,ib,stgs_dico,\
              klik,extrm);
//	    printf("OUT_STRING_BOOK2 out 1 COMPLETE_MEMORY_LINE it=%d kt=%d it_dep=%d jt_dep=%d  \n",*it,*kt,*it_dep,*jt_dep);
//	            printf("ss_mem[%d]=%s@@@\n",*it_dep,ss_mem[*it_dep]);
		    *nc0=0;
		    *lb=0;
		 }else{/*if(nc  == nc1){*/
	            *n_line = *n_line+1;
//	            fprintf(fp_out,"  %s\n",s+k);
	            strcpy(swork,"  ");
                    ADD_TO_MEMORY_LINE(swork,*it,ss_mem);
//	      printf("OUT_STRING_BOOK2 call 7 COMPLETE_MEMORY_LINE \n");
              COMPLETE_MEMORY_LINE(s+k,it,kt,it_dep,jt_dep,ss_mem,nb,\
              nb0,posit,pos_db,fp1,fph,box1,lbox2,w_loop1,s1_col,\
              s1_word,s1_klik,scroll_bzh,dico_b,iappel,ib,stgs_dico,\
              klik,extrm);
		    nc1=nc;
		    *nc0=0;
		    *lb=0;
		 }/*if(nc  == nc1){*/
	      i = i+j ;
	      s[i] = BFE;
//	      printf("end loop nc0=%d i=%d l=%d s[i]=%s@@@ \n",*nc0,i,l,s+i);
	      if(i >= l)lstop=1;
	   } /* if(s[i+j] == '\0'){*/
	} /*while(l == 0){*/
} /*** end of if s != NULL  ***/
}
/*********************************************************/
void DUMP_SS_MEM ( char ss_mem[][100], int i_dep, int i_fin)
/*
 *    Write the active part of ss_mem
 */
{//===========================================================
int i,i1,i2,iem,j,ii;
   iem=ISS_MAX;
      i1=i_dep;
      while(i1 < 1)i1=i1+ISS_MAX;
      while(i1 > ISS_MAX)i1=i1-ISS_MAX;
      i2=i_fin;
      while(i2 < 1)i2=i2+ISS_MAX;
      while(i2 > ISS_MAX)i2=i2-ISS_MAX;
   if(i1 == i2){
      printf("DUMP ss_mem[%d]=%s@@@@\n",i1,ss_mem[i1]);
      return;
   }//if(i_dep == i_fin){
   i=i1;
   j=0;
   ii=0;
   while(j < ISS_MAX && ii == 0){ 
      ++j;
      if(i == i2)ii=1;
      printf("DUMP ss_mem[%d]=%s@@@@\n",i,ss_mem[i]);
      ++i;
      if(i > ISS_MAX)i=i-ISS_MAX;
   }//while(j < ISS_MAX && ii == 0){
   return;
}//===========================================================
/*********************************************************/
int  CURRENCY(unsigned char c)
/*
 *   is a character a $, a pound or a euro sign ?
 */
{//===========================================================
int i,j;
   j=0;
   i = (int) c;
   if(i < 0 ) i=i+256;
   if(i ==36){ // a $
      j=1;
      return(j);
   }//if(i ==36){
   if(i == 128){ // a euro
      j=1;
      return(j);
   }//if(i ==36){
   if(i == 163){ // a pound
      j=1;
      return(j);
   }//if(i ==36){
   if(i == 164){ // a local currency
      j=1;
      return(j);
   }//if(i ==36){
   return(j);
}//===========================================================
